unit Unit70;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, ExtCtrls, Menus;

type
  TForm70 = class(TForm)
    BitBtn1: TBitBtn;
    Memo1: TMemo;
    Panel1: TPanel;
    Label1: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Edit1: TEdit;
    edit4: TEdit;
    edit5: TEdit;
    BitBtn2: TBitBtn;
    BitBtn4: TBitBtn;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Quit1: TMenuItem;
    InportFormula1: TMenuItem;
    ExportFormula1: TMenuItem;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    Label2: TLabel;
    Label5: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    edit6: TEdit;
    edit7: TEdit;
    ListBox1: TListBox;
    RadioGroup1: TRadioGroup;
    Panel2: TPanel;
    Edit3: TEdit;
    Label6: TLabel;
    Edit2: TEdit;
    Edit8: TEdit;
    Label7: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Edit9: TEdit;
    Label12: TLabel;
    Label13: TLabel;
    Panel3: TPanel;
    Label14: TLabel;
    procedure init_actice(Sender: TObject);
    procedure calcule_densite(Sender: TObject);
    procedure sortie(Sender: TObject);
    procedure BitBtn4Click(Sender: TObject);
    procedure importation_formule(Sender: TObject);
    procedure ExportFormula1Click(Sender: TObject);
    //procedure entree_density_range(Sender: TObject);
    //procedure entree_z_range(Sender: TObject);
    procedure set_formule(Sender: TObject);
    procedure selection_mode(Sender: TObject);
    procedure rase(Sender: TObject);
    procedure Edit2Change(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form70         : TForm70;
  nombre_mailles : integer;

implementation

{$R *.DFM}
uses
  unit1,mathhkl,truecell,lepage;

var
  z_min,z_max                            : integer;
  d_min,d_max,Eatom_vol,Tatom_vol,p,vol  : double;
  nb_nonH                                : integer;

procedure read_range;
//-------------------
var
  s            : string;
  ier          : integer;
begin

//Limites en densit
  with form70 do begin
      s:=trim(edit4.text);
      if (s = '')then d_min:=0 else begin
        val(s,d_min,ier);
        if(ier > 0)then begin
          erreur('Read error  (Min d)');
          edit4.SetFocus;
          exit;
        end;
      end;
      s:=trim(edit5.text);
      if (s = '')then d_max:=0 else begin
         val(s,d_max,ier);
         if(ier > 0)then begin
          erreur('Read error (Max d)');
          edit5.SetFocus;
          exit;
         end ;
      end;

//Limites en Z
      s:=trim(edit6.text);
      if (s = '')then z_min:=0 else begin
        val(s,z_min,ier);
        if(ier > 0)then begin
          erreur('Read error  (Min Z)');
          edit6.SetFocus;
          exit;
        end;
      end;
      s:=trim(edit7.text);
      if (s = '')then z_max:=0 else begin
         val(s,z_max,ier);
         if(ier > 0)then begin
          erreur('Read error (Max Z)');
          edit7.SetFocus;
          exit;
         end ;
      end;
  end;
end;

procedure re_set;
//--------------
var
  i  : integer;
  s  : string;
begin
  with form70 do begin
    listbox1.clear;
    label14.caption:='';
    if (provenance = 'unit1')then begin
      listbox1.items.add(form1.listbox4.items[0]);
      for i:=1 to nombre_mailles do begin
        s:=form1.listbox4.items[i];
        listbox1.items.add(s);
      end;
    end;
    if (provenance = 'truecell')then begin
      s:='Syst.   a      b      c    alpha  beta   gamma     V ';
      listbox1.items.add(s);
      for i:=0 to nombre_mailles-1 do begin
        s:=copy(ftruecell.listbox4.items[i],1,54);
        listbox1.items.add(s);
      end;
    end;
    if (provenance = 'lepage') then begin
      s:='Syst.   a      b      c    alpha  beta   gamma     V ';
      listbox1.items.add(s);
      for i:=0 to nombre_mailles-1 do begin
        s:=copy(flepage.listbox2.items[i],1,54);
        listbox1.items.add(s);
      end;
    end;
  end;
end;

procedure TForm70.init_actice(Sender: TObject);
//----------------------------------------------
begin
  edit1.text:=formule;
  (*str(eatom_vol:8:2,s);
  edit2.text:=s;*)
end;

procedure Calcule_masse_moleculaire;
//---------------------------------
var
  s,s1,s2                       : string;
  c                             : char;
  is1,is2,i,n,j,k,ier,n1,n2,m   : integer;
  elem,nb_elem                  : array[1..20] of string[3];
  d                             : double;

const el : array [1..103] of string[3] =
('H ','He','Li','Be','B ','C ','N ','O ','F ','Ne','Na','Mg','Al','Si','P ',
'S ','Cl','Ar','K ','Ca','Sc','Ti','V ','Cr','Mn','Fe','Co','Ni','Cu','Zn',
'Ga','Ge','As','Se','Br','Kr','Rb','Sr','Y ','Zr','Nb','Mo','Tc','Ru','Rh',
'Pd','Ag','Cd','In','Sn','Sb','Te','I ','Xe','Cs','Ba','La','Hf','Ta','W ',
'Re','Os','Ir','Pt','Au','Hg','Tl','Pb','Bi','Po','At','Rn','Fr','Ra','Ac',
'Ce','Pr','Nd','Pm','Sm','Eu','Gd','Tb','Dy','Ho','Er','Tm','Yb','Lu','Th',
'Pa','U ','Np','Pu','Am','Cm','Bk','Cf','Es','Fm','Md','No','Lr');

const masse : array [1..103] of double =
(  1.00794,   4.00260,   6.94100,   9.01218,  10.81100,  12.01100,  14.00674,
  15.99940,  18.99840,  20.17970,  22.98977,  24.30500,  26.98154,  28.08550,
  30.97362,  32.06600,  35.45270,  39.94800,  39.09830,  40.07800,  44.95591,
  47.88000,  50.94150,  51.99610,  54.93085,  55.84700,  58.93320,  58.69000,
  63.54600,  65.39000,  69.72300,  72.61000,  74.92159,  78.96000,  79.90400,
  83.80000,  85.46780,  87.62000,  88.90585,  91.22400,  92.90638,  95.94000,
  98.91000, 101.07000, 102.90550, 106.42000, 107.86820, 112.41100, 114.82000,
 118.71000, 121.75000, 127.60000, 126.90447, 131.29000, 132.90543, 137.32700,
 138.90550, 178.49000, 180.94790, 183.85000, 186.20700, 190.20000, 192.22000,
 195.08000, 196.96654, 200.59000, 204.38330, 207.20000, 208.98037, 209.00000,
 210.00000, 222.00000, 223.00000, 226.02500, 227.02800, 140.11500, 140.90765,
 144.24000, 145.00000, 150.36000, 151.96500, 157.25000, 158.92534, 162.50000,
 164.93032, 167.26000, 168.93421, 173.04000, 174.96700, 232.03810, 231.03588,
 238.02890, 237.04800, 244.00000, 243.00000, 247.00000, 247.00000, 251.00000,
 254.00000, 257.00000, 258.00000, 259.00000, 260.00000);

begin
  with form70 do begin
    label14.caption:='';
    if (radiogroup1.itemIndex = -1)then begin
      beep;
      erreur('Select the range mode');
      radiogroup1.setfocus;
      exit;
    end;

//Suppression des doubles blancs
    if (edit1.text = '')then begin
      erreur('No formula');
      beep;
      exit;
    end;

    read_range;
    if (d_min = 0)and (d_max = 0) and (z_min = 0)and (z_max = 0)then begin
      erreur('no range selected');
      beep;
      exit;
    end;
    if (d_min > d_max)then begin
      erreur('Range error in density');
      beep;
      edit4.Focused;
      exit;
     end;
    if (z_min > z_max)then begin
      erreur('Range error in Z');
      beep;
      edit6.Focused;
      exit;
    end;

//dcodage de la formule chimique
    s:=trim(edit1.text);
    while (pos('  ',s) > 0)do delete(s,pos('  ',s),1);

    n:=0;
    if (s = '')then exit;
    s1:='';
    s2:='';
    p:=0;
    n1:=0;
    n2:=0;

    repeat
      if (pos(' ',s) = 0)then begin
        s1:=trim(s);
        s:='';
      end else begin
        s1:=trim(copy(s,1,pos(' ',s)));
        delete(s,1,pos(' ',s));
      end;
      n:=n+1;
      elem[n]:='';
      nb_elem[n]:='';
      for i:=1 to length(s1) do begin
        c:=s1[i];
        if (ord (c) < 48) or (ord(c) > 57)then elem[n]:=elem[n]+c
                                        else nb_elem[n]:=nb_elem[n]+c;
      end;
      if (nb_elem[n] = '') then nb_elem[n]:='1'
    until (s = '');

//------------------------------------------------------------------------------
//Recherche des indices non accols aux symboles (ex: O 3)
    for i:=1 to n do begin
      ier:=0;
      s1:=trim(elem[i]);
      if (s1 = '')then begin
        nb_elem[i-1]:=nb_elem[i];   //Ce symbole appartient  l'element prcdent
        nb_elem[i]:='';
        continue;
      end;
    end;
    m:=0;
    for i:=1 to n do begin
      if (elem[i] = '') and (nb_elem[i] = '')then continue;
      m:=m+1;
      elem[m]:=elem[i];
      nb_elem[m]:=nb_elem[i];
    end;
    n:=m;
//------------------------------------------------------------------------------

    s:='';
    for i:=1 to n do begin
      s1:=trim(uppercase(elem[i]));
      s2:=trim(lowercase(elem[i]));

//Erreur d'criture
      if (s1 = '') or (s2 = '') then begin
        erreur('Formula error');
        beep;
        exit;
      end;
      if (length(s1) = 2)then s1[2]:=s2[2];

//vrification des noms d'lments
      ier:=1;
      for j:=1 to 103 do begin
        if (trim(el[j]) = s1) then begin
          ier:=0;
          break;
        end;
      end;
      if (ier = 1)then begin
        erreur('Formula error');
        beep;
        exit;
      end;

      elem[i]:=s1;
      s:=s+s1+nb_elem[i]+' ';
    end;
    edit1.text:=s;
    formule:=s;

//Calcul de la masse molculaire
    p:=0;
    nb_nonH:=0;
    for i:=1 to n do begin
      for j:=1 to 103 do begin
        if (trim(el[j]) = elem[i]) then begin
          if (trim(elem[i]) <> 'H')then nb_nonH:=nb_nonH+strtoint(nb_elem[i]);
          s1:=trim(nb_elem[i]);
          p:=p+ masse[j]*strtoint(s1);
          break;
        end;
      end;
    end;
    str(p:10:2,s);
    edit3.visible:=true;
    edit3.text:=s;
    edit8.text:=inttoStr(nb_nonH);
    s:=trim(edit2.text);
    val(s,Eatom_vol,ier);
    edit9.text:=inttostr(round(nb_nonH*Eatom_vol));
  end;
end;

procedure TForm70.calcule_densite(Sender: TObject);
//------------------------------------------------
var
  s,s1,s2,s_unit1    : string;
  i,j,k,n1,n2,ier    : integer;
   d                 : double;
begin
  Calcule_masse_moleculaire;

//Calcul de la densit
  (*s:=trim(listbox1.items[0]);
  listbox1.items[0]:=s+
  '     --------------------------density------------------------------'; *)

  //re_set;
  listbox1.clear;
  if (provenance = 'unit1')then
  label14.caption:='NbI/I20  FOM   V/V1    a      b      c   alpha   beta   gamma    Vol.'
  +'       Z   d     T.Atom.vol.   Ratio';
  if (provenance = 'truecell') or (provenance = 'lepage')then
  label14.caption:='Syst.   a      b      c    alpha  beta   gamma     V '
  +'         Z   d     T.Atom.vol.   Ratio';
  label14.left:=0;
  for i:=1 to nombre_mailles do begin
    if (provenance = 'unit1')   then s_unit1:=trim(form1.listbox4.items[i]);
    if (provenance = 'truecell')then s_unit1:=copy(ftruecell.listbox4.items[i-1],1,54);
    if (provenance = 'lepage')  then s_unit1:=copy(flepage.listbox2.items[i-1],1,54);
    listbox1.items.add(s_unit1);
    s:=s_unit1;
    while (pos(' ',s) > 0) do delete(s,1,pos(' ',s));
    s:=trim(s);
    val(s,vol,ier);
    if (ier > 0) or (abs(vol) < 0.00001)then begin
      erreur('Volume error at '+inttostr(i)+' cell: ');
      beep;
      exit;
    end;

    if (radiogroup1.ItemIndex = 0) then begin
      n1:=round(d_min*6.02*vol/(10*p))-1;
      n2:=round(d_max*6.02*vol/(10*p))+1;
    end else if (radiogroup1.itemIndex = 1)then begin;
      n1:=z_min;
      n2:=z_max;
    end else begin
      erreur('Range error');
      beep;
      exit;
    end;;
    if (n1 < 1)then n1:=1;
    if (n2 < 1)then n2:=1;

    s1:='';
    for j:=n1 to n2 do begin
      d:=10*p*j/(6.02*vol);
      if (radiogroup1.itemIndex = 0) then begin
        if (d < d_min) then continue;
        if (d > d_max) then break;
      end;
      str(j:2,s1);
      str(d:6:2,s2);
      s1:=s1+s2;
      Tatom_vol:=nb_nonH*Eatom_vol*j;
      str(Tatom_vol:12:2,s2);
      s1:=s1+s2;
      str(Tatom_vol/vol:10:2,s2);
      s1:=s1+s2;
      if (provenance = 'unit1') then for k:=1 to 74 do s1:=' '+s1;
      if (provenance = 'truecell') or (provenance = 'lepage')
      then for k:=1 to 60 do s1:=' '+s1;
      listbox1.items.add(s1);
    end;
  end;
  listbox1.visible:=true;
  edit3.visible:=true;
  listbox1.itemindex:=0;
  beep;
end;

procedure TForm70.sortie(Sender: TObject);
//-----------------------------------------
begin
  close;
end;

procedure TForm70.BitBtn4Click(Sender: TObject);
//-----------------------------------------------
var
    CmdFile      : Pchar;
    iwin,i,n     : integer;
    nomf         : TextFile;
    s,s1,s2      : string;
begin
  assignFile(nomf,'density.tmp');
  rewrite(nomf);
  s:=DateToStr(date);
  Writeln(nomf,'CHEKCELL  '+s);
  writeln(nomf,'Density results for ',formule);
  if (radiogroup1.itemindex = 0)then
  writeln(nomf,'Min. d=',d_min:6:2,  '  Max. d=',d_max:6:2);
  if (radiogroup1.itemindex = 1)then
  writeln(nomf,'Min. Z=',Z_min:2,'      Max. Z=',Z_max:2);
  (*writeln(nomf,
  '                                                                           Z'
  +'   D  TAtom vol Ratio');  *)

  writeln(nomf);
  s:=label14.caption;
  writeln(nomf,s);
  for i:=0 to listbox1.items.count-1 do writeln(nomf,listbox1.items[i]);
  CloseFile(nomf);
  CmdFile:='write.exe density.tmp';
  iwin:=WinExec(CmdFile,5);
end;

procedure TForm70.importation_formule(Sender: TObject);
//-----------------------------------------------------
var
   nomf  : textfile;
   s     : string;
   s9    : string[9];
   i     : integer;
begin
  if (opendialog1.execute) then begin
    s:=opendialog1.filename;
    if (trim(s) = '')then exit;
    assignfile(nomf,s);
    reset(nomf);
    readln(nomf,formule);
    edit1.text:=formule;

//densit
    readln(nomf,s9,d_min,d_max);
    str(d_min:6:2,s);
    edit4.text:=s;
    str(d_max:6:2,s);
    edit5.text:=s;
//Z
    readln(nomf,s9,z_min,z_max);
    str(z_min:3,s);
    edit6.text:=s;
    str(z_max:3,s);
    edit7.text:=s;
    
    closefile(nomf);
  end;
  radiogroup1.itemIndex:=0;
  calcule_masse_moleculaire;
  panel2.visible:=true;
end;

procedure TForm70.ExportFormula1Click(Sender: TObject);
//-----------------------------------------------------
var
   nomf  : textfile;
   s     : string;
   i     : integer;
begin
  if (formule = '')then formule:=edit1.text;
  if (formule = '')then begin
      erreur('No formula');
      exit;
  end;
  if (savedialog1.execute) then begin
    s:=savedialog1.filename;
    if (trim(s) = '')then exit;
    if (pos('.fml',s) = 0)then s:=s+'.fml';
    read_range;
    assignfile(nomf,s);
    rewrite(nomf);
    writeln(nomf,formule);
    writeln(nomf,'D range: ',d_min:6:2,d_max:6:2);
    writeln(nomf,'Z range: ',z_min:3,z_max:3);
    closefile(nomf)
  end;
end;
 (*
procedure TForm70.entree_density_range(Sender: TObject);
//-----------------------------------------------------
begin
  edit6.text:='';
  edit7.text:='';
  z_min:=0;
  z_max:=0;
end;

procedure TForm70.entree_z_range(Sender: TObject);
//------------------------------------------------
begin
  edit4.text:='';
  edit5.text:='';
  d_min:=0;
  d_max:=0;
end;
   *)
procedure TForm70.set_formule(Sender: TObject);
//---------------------------------------------
begin
  re_set;
  Calcule_masse_moleculaire;
  panel2.visible:=true;
  formule:=edit1.Text;
end;

procedure TForm70.selection_mode(Sender: TObject);
//------------------------------------------------
begin
  re_set;
end;

procedure TForm70.rase(Sender: TObject);
///////////////////////////////////////
begin
  re_set;
end;

procedure TForm70.Edit2Change(Sender: TObject);
//--------------------------------------------
var
 s            : string;
 ier          : integer;
begin
    s:=trim(edit2.text);
    if (nb_nonh = 0)then exit;
    val(s,Eatom_vol,ier);
    if (ier <> 0)then begin
      erreur('Estimated atom. vol. error');
      edit2.Focused;
      exit;
    end;
    edit9.text:=inttostr(round(nb_nonH*Eatom_vol));
    re_set;
end;

end.
