unit conditions;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, ExtCtrls;

type
  Tfconditions = class(TForm)
    ListBox1: TListBox;
    BitBtn1: TBitBtn;
    Panel1: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    procedure sortie(Sender: TObject);
    procedure affiche(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  fconditions: Tfconditions;

implementation

{$R *.DFM}
uses
  mathhkl, unit3b;

//var
//   npos0                                        : integer;

procedure traduit_clair(var s1,s2:string);
//---------------------------------------
var
  s,chaine                : string;
  i,n,o                   : integer;
const
   action_do : array[1..29] of string =
   ('HN2','HN4','HN3','AH>AK','AH>AL','H+KN2','-HKLN3','KN2','KN4','KN3',
   'AK>AL','AK>AH','K+LN2','H-KLN3','LN2','LN4','LN3','AL>AH','AL>AK','L+HN2',
   'HK-LN3','HKLN2','H+KN4','K+LN4','L+HN4','2H+LN4','2K+HN4','2L+KN4','LN6');

   frase_do : array[1..29] of string =
   ('H=2n','H=4n','H=3n','H>K','H>L','H+K=2n','-H+K+L=3n','K=2n','K=4n','K=3n',
   'K>L','K>H','K+L=2n','H-K=3n','L=2n','L=4n','L=3n','L>H','L>K','L+H=2n',
   'H+K-L=3n','H+K+L=2n','H+K=4n','K+L=4n','L+H=4n','2H+L=4n','2K+H=4n',
   '2L+K=4n','L=6n');

begin
   s2:=s1;
   for i:=1 to 29 do begin
     s:=action_do[i];
     //n:=length(s);
     o:=pos(s,s2);
     if (o > 0) and (s2[o-1] = ' ') then begin
       delete(s2,o,length(s));
       s:=frase_do[i];
       insert(s,s2,o);
     end;
   end;
   s2:=lowercase(s2);
   while (pos(' ',s2) > 0)do begin
     s2[pos(' ',s2)]:=';';
   end;
   while (pos(';',s2) > 0)do begin
     i:= pos(';',s2);
     s2[i]:=',';
     chaine:='  ';
     insert(chaine,s2,i+1);
   end;
end;

Procedure decode_conditions(var ier:integer);{
---------------------------------------------}
var
   il,i,j,k,ibrav                  : integer;
   s,s1                            : string;

 const
   condition_si : array[1..18] of string =
   ('H=0','H<0','H>K','H>L','K=0','K<0','K>L','K>H','L=0','L<0','L>H','L>K',
   'H=K','K=L','L=H','H=-K','K=-L','L=-H');

   action_do : array[1..29] of string =
   ('HN2','HN4','HN3','AH>AK','AH>AL','H+KN2','-HKLN3','KN2','KN4','KN3',
   'AK>AL','AK>AH','K+LN2','H-KLN3','LN2','LN4','LN3','AL>AH','AL>AK','L+HN2',
   'HK-LN3','HKLN2','H+KN4','K+LN4','L+HN4','2H+LN4','2K+HN4','2L+KN4','LN6');

 begin
   fconditions.listbox1.clear;
   bravais:=copy(groupe_espace,1,1);
   ibrav:=ord(bravais[1]);
   if (ibrav <> 80)then begin
     fconditions.listbox1.items.add('Bravais lattice:');
   end;
   if(systeme = 'RHOM')then ibrav:=ord('P');
   s1:='';
   case ibrav of
      //80: s1:='';                                       {Primitif}
      73: fconditions.listbox1.items.add('h+k+l=2n');     {Corps centr}
      70: begin                                           {Faces centres}
             fconditions.listbox1.items.add('h+k=2n');
             fconditions.listbox1.items.add('k+l=2n');
             fconditions.listbox1.items.add('l+h=2n');
          end;
      65: fconditions.listbox1.items.add('h+k=2n');       {Face A centre}
      66: fconditions.listbox1.items.add('l+h=2n');       {Face B centre}
      67: fconditions.listbox1.items.add('h+k=2n');       {Face C centre}
      82: if (systeme = 'HEXA') then
      fconditions.listbox1.items.add('-h+k+l=3n');    //  rhombodrique index en Hexagonal}
   end;
   if (ibrav <> 80)then fconditions.listbox1.items.add('  ');

   if (nb_ligne_code > 0)then begin
     fconditions.listbox1.items.add('General position:');
   end else begin
     fconditions.listbox1.items.add('No condition');
     exit;
   end;

   for il:=1 to nb_ligne_code do begin

      // Conditions Si
      nb_condition_si[il]:=0;
      s:=ligne_codeEN[il];
      s:=trimright(s);s:=trimleft(s);

      //Traduction en clair des conditions d'existence
      traduit_clair(s,s1);
      fconditions.listbox1.items.add(s1);

      for i:=1 to 6 do begin   // 6 actions DO possibles?!
        if (pos('>',s) = 0) and (pos('<',s) = 0) and (pos('=',s) = 0)then break;
        j:=pos(' ',s);
        if (j = 0)then break;
        s1:=copy(s,1,j-1);s1:=trimleft(s1);
        delete(s,1,j);s:=trimright(s);s:=trimleft(s);
        ier:=1;
        for k:=1 to 18 do begin
          if (s1 = condition_si[k]) then begin
            nb_condition_si[il]:=nb_condition_si[il]+1;
            no_condition_si[il,nb_condition_si[il]]:=k;
            ier:=0;
            break;
          end;
        end;
        if (ier = 1) then begin
          erreur('Condition d''extinction '+s1+' non dcode');
          exit;
        end;
      end;

      //Action DO
      s:=trim(s);
      ier:=1;
      for i:=1 to 29 do begin
        if (s = action_do[i])then begin
          no_action_do[il]:=i;
          ier:=0;
          break;
        end;
      end;
      if (ier = 1) then begin
        erreur('Condition d''extinction '+s+' non dcode');
        exit;
      end;
    end;

 end;

procedure Tfconditions.sortie(Sender: TObject);
//---------------------------------------------
begin
  close;
end;

procedure Tfconditions.affiche(Sender: TObject);
//---------------------------------------------
var
   ier   : integer;
begin
 if (systeme = 'ORTH')then panel1.visible:=true else panel1.visible:=false;
 decode_conditions(ier);
end;



end.
