unit disp;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons,math;

type
  Tfdisp = class(TForm)
    Memo1: TMemo;
    BitBtn1: TBitBtn;
    procedure fin(Sender: TObject);
    procedure affiche_solution(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  fdisp: Tfdisp;

implementation

{$R *.DFM}
uses
  main,mathhkl_3;

type
   matrice3                           = array[1..3,1..3] of double ;
var
  celr                                : array[1..6] of real;
  theta_max,theta_min                 : real;
  r21                                 : matrice3;

procedure setmat;
//--------------
var
      a,b,c                                : double;
      sa,sb,sc,sbe,sce,ca,cb,cc            : double;
      cae,cbe,cce                          : double;
      q,v                                  : double;
      i,j                                  : integer;
begin
      a:=cel[1];
      b:=cel[2];
      c:=cel[3];
      ca:=cos(cel[4]/pir);
      cb:=cos(cel[5]/pir);
      cc:=cos(cel[6]/pir);
      sa:=sin(cel[4]/pir);
      sb:=sin(cel[5]/pir);
      sc:=sin(cel[6]/pir);
      q:=1.-ca*ca-cb*cb-cc*cc+2.*ca*cb*cc;
      v:=a*b*c*sqrt(q);
      celr[1]:=b*c*sa/v;
      celr[2]:=c*a*sb/v;
      celr[3]:=a*b*sc/v;
      cae:=(cb*cc-ca)/(sb*sc);
      cbe:=(cc*ca-cb)/(sc*sa);
      cce:=(ca*cb-cc)/(sa*sb);
      celr[4]:=arccos(cae);
      celr[4]:=celr[4]*pir;
      celr[5]:=arccos(cbe);
      sbe:=sin(celr[5]);
      celr[5]:=celr[5]*pir;
      celr[6]:=arccos(cce);
      sce:=sin(celr[6]);
      celr[6]:=celr[6]*pir;

{-----Orthonormalisation du rseau rciproque R21}
      for i:=1 to 3 do begin
        for j:=1 to 3 do begin
          r21[i,j]:=0;
        end;
      end;
      r21[1,1]:=celr[1];
      r21[1,2]:=celr[2]*cce;
      r21[1,3]:=celr[3]*cbe;
      r21[2,2]:=celr[2]*sce;
      r21[2,3]:=-celr[3]*sbe*ca;
      r21[3,3]:=1./cel[3];
  end;
  
procedure indx;{
---------------}
type raie = record
  hr,kr,lr,ext                  : integer;
  dr,dtheta                     : real;
end;

var
  h_groupe,k_groupe,l_groupe,systeme                   : integer;
  i,j,h,k,l,h1,h2,k1,k2,l1,l2,ier,n                    : integer;
  hh,kk,ll,hmax,kmax,lmax                              : integer;
  x,y,z,r2hkl,lbds2,dhkl                               : real;
  r2hkl_min,r2hkl_max,sithl                            : real;
  nr                                                   : integer;
  result                                               : array[1..10000] of ^raie;
  buf                                                  : raie;
  xlp,theta_rad,echel                                  : real;
  r1,r2,r3                                             : real;

  raies_indx                                           : array[1..1000] of raie;
  nb_raies_indx                                        : integer;

  s,s1,s2                                              : string;
  itab                                                 : array[1..20] of integer;

  nomf  : textfile;
label 1;

begin

   theta_max:=theta[nb_raies]+0.1;
   theta_min:=theta[1]-0.1;
// limites des boucles
  setmat;
  x:=2*sin(theta_max/(57.2957*2))/wl;
  r1:=x/sin(celr[6]/57.2957);
  r2:=x/sin(celr[4]/57.2957);
  r3:=x/sin(celr[5]/57.2957);
  if (r1 > r3)then hmax:=round(r1/celr[1])+1 else hmax:=round(r3/celr[1])+1;
  if (r1 > r2)then kmax:=round(r1/celr[2])+1 else kmax:=round(r2/celr[2])+1;
  if (r2 > r3)then lmax:=round(r2/celr[3])+1 else lmax:=round(r3/celr[3])+1;

  h1:=-hmax;
  h2:=hmax;
  k1:=-kmax;
  k2:=kmax;
  l1:=0;
  l2:=lmax;

  lbds2:=wl/2;
  r2hkl_min:=2*sin(theta_min/pir)/wl;
  r2hkl_min:=(r2hkl_min*r2hkl_min);
  r2hkl_max:=2*sin(theta_max/pir)/wl;
  r2hkl_max:=(r2hkl_max*r2hkl_max);


  nb_raies_indx:=0;
  systeme:=fmain.listbox2.itemIndex+1;
  if (systeme = 1)then begin   //c
    for h:=0 to h2 do begin
      for k:=0 to k2 do begin
        for l:=k to l2 do begin
          if (ier = 1)then continue;
          x:=r21[1,1]*h+r21[1,2]*k+r21[1,3]*l;
          y:=r21[2,1]*h+r21[2,2]*k+r21[2,3]*l;
          z:=r21[3,1]*h+r21[3,2]*k+r21[3,3]*l;
          r2hkl:=x*x+y*y+z*z;
          if(r2hkl < r2hkl_min) or (r2hkl > r2hkl_max) then continue;
          dhkl:=1/sqrt(r2hkl);

          nb_raies_indx:=nb_raies_indx+1;
          if (nb_raies_indx >= 9999)then begin
            erreur('Too many calculated reflections. Decrease the theta range');
            screen.cursor:=crdefault;
            for i:=1 to nb_raies_indx do dispose(result[i]);
            exit;
          end;
          new (result[nb_raies_indx]);
          with result[nb_raies_indx]^ do begin
            hr:=h;
            kr:=k;
            lr:=l;
            dr:=dhkl;
          end;
        end;
      end;
    end;
  end;

  if (systeme = 2)then begin   //q
    for h:=0 to h2 do begin
      for k:=0 to k2 do begin
        for l:=0 to l2 do begin
          if (ier = 1)then continue;
          x:=r21[1,1]*h+r21[1,2]*k+r21[1,3]*l;
          y:=r21[2,1]*h+r21[2,2]*k+r21[2,3]*l;
          z:=r21[3,1]*h+r21[3,2]*k+r21[3,3]*l;
          r2hkl:=x*x+y*y+z*z;
          if(r2hkl < r2hkl_min) or (r2hkl > r2hkl_max) then continue;
          dhkl:=1/sqrt(r2hkl);
          nb_raies_indx:=nb_raies_indx+1;
          if (nb_raies_indx >= 9999)then begin
            erreur('Too many calculated reflections. Decrease the theta range');
            screen.cursor:=crdefault;
            for i:=1 to nb_raies_indx do dispose(result[i]);
            exit;
          end;
          new (result[nb_raies_indx]);
          with result[nb_raies_indx]^ do begin
            hr:=h;
            kr:=k;
            lr:=l;
            dr:=dhkl;
          end;
        end;
      end;
    end;
  end;

  if (systeme = 5)then begin   //o
    for h:=0 to h2 do begin
      for k:=0 to k2 do begin
        for l:=0 to l2 do begin
          if (ier = 1)then continue;
          x:=r21[1,1]*h+r21[1,2]*k+r21[1,3]*l;
          y:=r21[2,1]*h+r21[2,2]*k+r21[2,3]*l;
          z:=r21[3,1]*h+r21[3,2]*k+r21[3,3]*l;
          r2hkl:=x*x+y*y+z*z;
          if(r2hkl < r2hkl_min) or (r2hkl > r2hkl_max) then continue;
          dhkl:=1/sqrt(r2hkl);
          nb_raies_indx:=nb_raies_indx+1;
          if (nb_raies_indx >= 9999)then begin
            erreur('Too many calculated reflections. Decrease the theta range');
            screen.cursor:=crdefault;
            for i:=1 to nb_raies_indx do dispose(result[i]);
            exit;
          end;
          new (result[nb_raies_indx]);
          with result[nb_raies_indx]^ do begin
            hr:=h;
            kr:=k;
            lr:=l;
            dr:=dhkl;
          end;
        end;
      end;
    end;
  end;

  if (systeme = 4)then begin   //h
    for h:=0 to h2 do begin
      for k:=h to k2 do begin
        for l:=0 to l2 do begin
          if (ier = 1)then continue;
          x:=r21[1,1]*h+r21[1,2]*k+r21[1,3]*l;
          y:=r21[2,1]*h+r21[2,2]*k+r21[2,3]*l;
          z:=r21[3,1]*h+r21[3,2]*k+r21[3,3]*l;
          r2hkl:=x*x+y*y+z*z;
          if(r2hkl < r2hkl_min) or (r2hkl > r2hkl_max) then continue;
          dhkl:=1/sqrt(r2hkl);
          nb_raies_indx:=nb_raies_indx+1;
          if (nb_raies_indx >= 9999)then begin
            erreur('Too many calculated reflections. Decrease the theta range');
            screen.cursor:=crdefault;
            for i:=1 to nb_raies_indx do dispose(result[i]);
            exit;
          end;
          new (result[nb_raies_indx]);
          with result[nb_raies_indx]^ do begin
            hr:=h;
            kr:=k;
            lr:=l;
            dr:=dhkl;
          end;
        end;
      end;
    end;
  end;

  if (systeme = 3)then begin   //r
    for h:=0 to h2 do begin
      for k:=h to h2 do begin
        if (h = 0) and (k = 0)then continue;
        for l:=-h2 to h2 do begin
          if (ier = 1)then continue;
          x:=r21[1,1]*h+r21[1,2]*k+r21[1,3]*l;
          y:=r21[2,1]*h+r21[2,2]*k+r21[2,3]*l;
          z:=r21[3,1]*h+r21[3,2]*k+r21[3,3]*l;
          r2hkl:=x*x+y*y+z*z;
          if(r2hkl < r2hkl_min) or (r2hkl > r2hkl_max) then continue;
          dhkl:=1/sqrt(r2hkl);
          nb_raies_indx:=nb_raies_indx+1;
          if (nb_raies_indx >= 9999)then begin
            erreur('Too many calculated reflections. Decrease the theta range');
            screen.cursor:=crdefault;
            for i:=1 to nb_raies_indx do dispose(result[i]);
            exit;
          end;
          new (result[nb_raies_indx]);
          with result[nb_raies_indx]^ do begin
            hr:=h;
            kr:=k;
            lr:=l;
            dr:=dhkl;
          end;
        end;
      end;
    end;
  end;

  if (systeme = 6)then begin   //m
    for h:=-h2 to h2 do begin
      for k:=0 to k2 do begin
        for l:=0 to l2 do begin
          if (ier = 1)then continue;
          x:=r21[1,1]*h+r21[1,2]*k+r21[1,3]*l;
          y:=r21[2,1]*h+r21[2,2]*k+r21[2,3]*l;
          z:=r21[3,1]*h+r21[3,2]*k+r21[3,3]*l;
          r2hkl:=x*x+y*y+z*z;
          if(r2hkl < r2hkl_min) or (r2hkl > r2hkl_max) then continue;
          dhkl:=1/sqrt(r2hkl);
          nb_raies_indx:=nb_raies_indx+1;
          if (nb_raies_indx >= 9999)then begin
            erreur('Too many calculated reflections. Decrease the theta range');
            screen.cursor:=crdefault;
            for i:=1 to nb_raies_indx do dispose(result[i]);
            exit;
          end;
          new (result[nb_raies_indx]);
          with result[nb_raies_indx]^ do begin
            hr:=h;
            kr:=k;
            lr:=l;
            dr:=dhkl;
          end;
        end;
      end;
    end;
  end;

  if (systeme = 7)then begin   //tr
    for h:=-h2 to h2 do begin
      for k:=-k2 to k2 do begin
        for l:=0 to l2 do begin
          if (ier = 1)then continue;
          x:=r21[1,1]*h+r21[1,2]*k+r21[1,3]*l;
          y:=r21[2,1]*h+r21[2,2]*k+r21[2,3]*l;
          z:=r21[3,1]*h+r21[3,2]*k+r21[3,3]*l;
          r2hkl:=x*x+y*y+z*z;
          if(r2hkl < r2hkl_min) or (r2hkl > r2hkl_max) then continue;
          dhkl:=1/sqrt(r2hkl);
          nb_raies_indx:=nb_raies_indx+1;
          if (nb_raies_indx >= 9999)then begin
            erreur('Too many calculated reflections. Decrease the theta range');
            screen.cursor:=crdefault;
            for i:=1 to nb_raies_indx do dispose(result[i]);
            exit;
          end;
          new (result[nb_raies_indx]);
          with result[nb_raies_indx]^ do begin
            hr:=h;
            kr:=k;
            lr:=l;
            dr:=dhkl;
          end;
        end;
      end;
    end;
  end;

//Mise en ordre
  for i:=1 to nb_raies_indx-1 do begin
    for j:=i+1 to nb_raies_indx do begin
      if (result[i]^.dr < result[j]^.dr) then begin
        buf:=result[j]^;
        result[j]^:=result[i]^;
        result[i]^:=buf;
      end;
    end;
  end;

//Regroupement des raies de mme dhkl
  nr:=0;
  for i:=1 to nb_raies_indx do begin
    if (result[i]^.dr = 0) then continue; //Cette raie a dja t intgre dans un groupe
    nr:=nr+1;
    if (nr >= 10000)then begin
      erreur('Too many calculated reflections (>10000)');
      nr:=nr-1;
      goto 1
    end;
    with result[i]^ do begin
       h_groupe:=hr;
       k_groupe:=kr;
       l_groupe:=lr;
    end;
    if (i < nb_raies_indx) then begin
      for j:=i+1 to nb_raies_indx do begin
        if(result[j]^.dr = 0)then continue;     //La raie n'existe plus
        if (abs(result[j]^.dr - result[i]^.dr) > 0.0001)then break;
        if (result[j]^.hr >= 0) and  (result[j]^.kr >= 0)
        and (result[j]^.lr >= 0) then begin     //On choisit les indices positifs
          h_groupe:=result[j]^.hr;
          k_groupe:=result[j]^.kr;
          l_groupe:=result[j]^.lr;
        end;
        result[j]^.dr:=0;
     end;
    end;
//???????????????????????????????????????????????????????????????????????????
    with raies_indx[nr] do begin
      hr:=h_groupe;
      kr:=k_groupe;
      lr:=l_groupe;
      dr:=result[i]^.dr;
      ext:=0;
      dtheta:=pir*arcsin(wl/(2*dr));
      ang_calc[nr]:=dtheta;
      h_calc[nr]:=hr;
      k_calc[nr]:=kr;
      l_calc[nr]:=lr;
    end;
//????????????????????????????????????????????????????????????????????????????

    //dispose(result[i]);
  end;
  1: for i:=1 to nb_raies_indx do  dispose(result[i]);
  nb_raies_indx:=nr;

 (* writeln(nomf);
  writeln(nomf,'Apres tri:');
    for i:=1 to nb_raies_indx do begin
    with raies_indx[i] do begin
      writeln(nomf,i:5,hr:3,kr:3,lr:3,dr:8:4);
    end;
  end;
  closefile(nomf);  *)


    sigma:=0;
    nb_verif:=0;
    nb_coinc:=0;
    for i:=1 to nb_raies do begin
      n:=0;
      for j:=1 to nb_calc do begin

        str(h_calc[j]:3,s);
        str(k_calc[j]:3,s1);
        s:=s+s1;
        str(l_calc[j]:3,s1);
        s:=s+s1;
        str(2*ang_calc[j]:8:3,s1);
        s:=s+s1;

        if (ang_calc[j]-eps > theta[i]) then break;
        ax:=abs(theta[i]-ang_calc[j]);
        if (ax < eps)then begin
          n:=n+1;
          s2:=s;
          l:=length(s2);
          if (n = 1)then begin
            str(2*theta[i]:8:3,s1);
            s2:=s2+s1;
          end else for k:=1 to 8 do s2:=s2+' ';
          str(2*(-ang_calc[j]+theta[i]):8:3,s1);
          s2:=s2+s1;

          fdisp.memo1.lines.add(s2);
        end;
      end;
    end;
end;

procedure Tfdisp.fin(Sender: TObject);
//------------------------------------
begin
  close;
end;

procedure Tfdisp.affiche_solution(Sender: TObject);
//-------------------------------------------------
var
  s,s1,sl                      : string;
  ier                       : integer;
  v                         : real;
begin

    sl:=fmain.listbox3.items[fmain.listbox3.itemindex];
    s1:=trim(copy(sl,6,8));
    val(s1,cel[1],ier);
    s1:=trim(copy(sl,14,8));
    val(s1,cel[2],ier);
    s1:=trim(copy(sl,22,8));
    val(s1,cel[3],ier);
    s1:=trim(copy(sl,30,8));
    val(s1,cel[4],ier);
    s1:=trim(copy(sl,38,8));
    val(s1,cel[5],ier);
    s1:=trim(copy(sl,46,8));
    val(s1,cel[6],ier);
    s1:=trim(copy(sl,54,8));
    val(s1,cel[7],ier);

    //memo1.lines.add(' ');
    s1:=trim(copy(sl,1,4));
    //memo1.lines.add('Solution Nb '+s1);
    caption:='Solution Nb '+s1;
    memo1.lines.add('');
    s:='';
    str(cel[1]:7:3,s1);
    s:=  '       a='+s1;
    str(cel[2]:7:3,s1);
    s:=s+'       b='+s1;
    str(cel[3]:7:3,s1);
    s:=s+'       c='+s1;
    memo1.lines.add(s);

    s:='';
    str(cel[4]:7:2,s1);
    s:=  '   alpha='+s1;
    str(cel[5]:7:2,s1);
    s:=s+'    beta='+s1;
    str(cel[6]:7:2,s1);
    s:=s+'   gamma='+s1;
    memo1.lines.add(s);

    memo1.lines.add(' ');
    str(cel[7]:8:1,s1);
    memo1.lines.add('           vol.='+trim(s1));

    s1:=trim(copy(sl,79,7));
    memo1.Lines.add('Nb calc/Nb obs ='+trim(s1));

    s1:=copy(sl,85,10);
    memo1.lines.add('          sigma='+trim(s1));
    memo1.lines.add(' ');
    memo1.Lines.add('  h  k  l 2Th calc 2Th obs   Dif.');

  indx;
end;

end.


