unit fichiers;

interface

uses
  SysUtils, WinTypes, Controls, StdCtrls, dialogs, math;

//Fichiers mesures
   procedure lidif_brucker;
   procedure lidif_xfit;
   procedure lidif_winfit;
   procedure lidif_philips;
   procedure lidif_crysfirecdt;
   procedure lidif_prn;

//Fichiers profil
   procedure liraw_brucker;
   procedure liraw_rietveld;
   procedure liraw_cpi;
   procedure liraw_philips;

//Ecriture des fichiers paramtres de maille
   procedure ecrit_dif;
   procedure ecrit_prn;
   procedure ecrit_sim;
   procedure ecrit_cpi;

// Lecture des fichiers paramtres de maille
   procedure lit_fichier_cry;
   procedure lit_fichier_icsd;

implementation

uses mathhkl;

procedure lidif_brucker;
//---------------------
var
  i,j,longueur_header                : integer;
  i2,h,k,l,n                         : smallint;
  i4                                 : longint;
  c4                                 : array[1..4] of char;
  c2                                 : array[1..2] of char;
  c60                                : array[1..60]of char;
  c                                  : char;
  x,y,ech                            : single;
  r8                                 : double;
  s,s1,nom_fichier                   : string;
  nomf                               : file;
  nb_total_bytes,step_count,nb_tranches      : integer;
  ier                                        : integer;
  dtheta_depart,step_size,ymax,ymax_dif      : real;

 begin
  lambda_dif:=0;
  lambda1_dif:=0;
  lambda1_dif:=0;
  ratio_dif:=0;
  anode_dif:='';
  theta_min_dif:=0;
  theta_max_dif:=0;
//Brucker Dif binaire
  assignFile(nomf,nom_fichier_dif);
  reset(nomf,1);
  blockread(nomf,c4,4);
  s:='';
  for i:=1 to 4 do begin
    s[i]:=c4[i];
  end;
  {--------------------Lecture de fichier type DIF2----------------------------}
  s:=trimright(s);
  if (s = 'DIF2')then begin
    {Lecture de nr}
    blockread(nomf,i,4);                               // offset 8

    //titre (aout 99)
    s:='';
    for i:=1 to 32 do s:=s+'*';
    blockread(nomf,c60,32);                            //        40
    for i:=1 to 32 do s[i]:=c60[i];
    titre_dif:=trim(s);

    for i:=1 to 148 do blockread(nomf,c,1);            // offset 188
    c2:='';
    blockread(nomf,c2,2);
    for i:=1 to 2 do anode_dif[i]:=c2[i];              // offset 190
    {longueur d'onde}
    blockread(nomf,x,4);
    lambda1_dif:=x;
    {lambda2}
    blockread(nomf,x,4);
    lambda2_dif:=x;
    {ratio}
    blockread(nomf,x,4);
    ratio_dif:=x;
    for i:=1 to 54 do blockread(nomf,c,1);
    {dimension du header}
    blockread(nomf,i2,2);
    nb_total_bytes:=i2;
    for i:=1 to 4 do blockread(nomf,c,1);
    {nb. de pics}
    blockread(nomf,i2,2);
    nb_raies_dif:=i2;
    for i:=1 to 10 do blockread(nomf,c,1);
    {step_size}
    blockread(nomf,x,4);
    step_size:=x;
    {2 thta de dpart}
    blockread(nomf,x,4);
    dtheta_depart:=x;
    for i:=1 to 70 do blockread(nomf,c,1);
    {lecture des enregistrements variables}
    if (nb_total_bytes > 96)then begin
      for i:=1 to nb_total_bytes-96 do blockread(nomf,c,1);
    end;
    ymax:=0;
    for i:=1 to nb_raies_dif do begin
      blockread(nomf,x,4);
      blockread(nomf,y,4);
      if (y > ymax) then ymax:=y;
      for j:=1 to 8 do blockread(nomf,c,1);
      theta_dif[i]:=x;
      theta_dif_old[i]:=x;
      intensite_dif[i]:=y;
    end;
  //end;
  //  Juin 98: Lecture des fichiers .DIF de DIFFRAC+
  // (commencent en fait par DIF1.00 ou DIF1.01 )
  end else if (s = 'DIF1')then begin
      for i:=1 to 8 do blockread(nomf,c,1);     //offset 12
      blockread(nomf,i,4);                      // offset 16
      nb_tranches:=i;
      //titre (aout 99)
      for i:=1 to 310 do blockread(nomf,c,1);   //offset 326
      s:='';
      for i:=1 to 60 do s:=s+'*';
      blockread(nomf,c60,60);                   //       386
      for i:=1 to 60 do s[i]:=c60[i];
      titre_dif:=trim(s);
      for i:=1 to 222 do blockread(nomf,c,1);   //offset 608
      blockread(nomf,c4,4);                     // offset 612
      anode_dif:='';
      for i:=1 to 2 do begin
       anode_dif[i]:=c4[i];
      end;
      for i:=1 to 4 do blockread(nomf,c,1);     // offset 616
      blockread(nomf,r8,8);
      lambda_dif:=r8;
      blockread(nomf,r8,8);
      lambda1_dif:=r8;
      blockread(nomf,r8,8);
      lambda2_dif:=r8;
      blockread(nomf,r8,8);                      //K beta
      blockread(nomf,r8,8);                      // offset 656
      ratio_dif:=r8;
      for i:=1 to 56 do blockread(nomf,c,1);     // offset 712
                                                 //Range header
      for i:=1 to 8 do blockread(nomf,c,1);      // offset 8
      // Nombre de raies
      blockread(nomf,i,4);                       // offset 12
      nb_raies_dif:=i;
      blockread(nomf,i,4);                       // offset 16
      blockread(nomf,r8,8);                       // offset 24  theta dpart
      blockread(nomf,r8,8);                       // offset 32 2thta dpart
      theta_min_dif:=r8;
      for i:=1 to 216 do blockread(nomf,c,1);    // offset 248
      // Lambda
      blockread(nomf,r8,8);                      // offset 256
      lambda_dif:=r8;

      // Enregistrements supplmentaires ?
      blockread(nomf,i,4);                       // offset260
      longueur_header:=i;

      for i:=1 to 44 do blockread(nomf,c,1);     //Offset 304

      if (longueur_header <> 0 )then              //Enregistrements supplmentaires
      for i:=1 to longueur_header do blockread(nomf,c,1);

      // Lecture des pics
      ymax:=0;
      for i:=1 to nb_raies_dif do begin
        blockread(nomf,r8,8);
        theta_dif[i]:=r8;
        theta_dif_old[i]:=r8;
        blockread(nomf,x,4);
        intensite_dif[i]:=x;
        if (x > ymax )then ymax:=x;
        blockread(nomf,h,2);
        blockread(nomf,k,2);
        blockread(nomf,l,2);
        for j:=1 to 6 do blockread(nomf,c,1);
    end;
 end else begin
    Erreur('Unknown file type!');
    exit;
  end;
  closefile(nomf);
  ech:=100/ymax;
  ymax_dif:=ymax;
  for i:=1 to nb_raies_dif do intensite_dif[i]:=intensite_dif[i]*ech;
  theta_min_dif:=theta_dif[1]-epsa;
  theta_max_dif:=theta_dif[nb_raies_dif]+epsa;
end;

Procedure lidif_xfit;
//-------------------
var
  nomf                       : TextFile;
  s42                        : string[42];
  s20                        : string[20];
  s,s1,nom_fichier           : string;
  n,ier,i,j                  : integer;
  x,ech                      : real;
begin
  teste_fichier_unix(nom_fichier_dif,ier);
  if (ier > 0)then  nom_fichier:='dummy.tmp' else nom_fichier:=nom_fichier_dif;

  assignFile(nomf,nom_fichier);
  reset(nomf);
  theta_min_dif:=0;
  theta_max_dif:=0;
  readln(nomf,s);
  if (trim(s) = '')then readln(nomf,s);
  s:=trim(s);
  i:=pos('Code',s);
  j:=pos('Th2',s);
  if (i < j)then begin
    n:=0;
    while not(eof(nomf)) do begin
      readln(nomf,s);
      if (trim(s) = '')then continue;
      s:=trim(copy(s,42,14));
      val(s,x,ier);
      if (ier > 0)then begin
        erreur('Error in the .txt file');
        halt;
      end;
      n:=n+1;
      theta_dif[n]:=x;
      theta_dif_old[n]:=x;
      intensite_dif[n]:=100;
    end;
    nb_raies_dif:=n;
  end else begin
    n:=0;
    ymax:=0;
    while not(eof(nomf)) do begin
      readln(nomf,s);
      if (trim(s) = '')then readln(nomf,s);
      s1:=copy(s,23,8);
      s1:=trim(s1);
      val(s1,x,ier);
      n:=n+1;
      theta_dif[n]:=x;
      theta_dif_old[n]:=x;
      s1:=copy(s,57,10);
      s1:=trim(s1);
      val(s1,x,ier);
      if (x = 0)then begin
        n:=n-1;
        continue;
      end;
      intensite_dif[n]:=x;
      if (ymax < x)then ymax:=x;
    end;
    nb_raies_dif:=n;
    ech:=100/ymax;
    ymax_dif:=ymax;
    for i:=1 to nb_raies_dif do intensite_dif[i]:=intensite_dif[i]*ech;
  end;
  theta_min_dif:=theta_dif[1]-epsa;
  theta_max_dif:=theta_dif[nb_raies_dif]+epsa;
  if (theta_max_dif >= 180)then theta_max_dif:=179;
  closefile(nomf);
end;

Procedure lidif_prn;
//-----------------
var
  nomf                       : TextFile;
  s42                        : string[42];
  s20                        : string[20];
  s,s1,nom_fichier           : string;
  n,ier,i,j                  : integer;
  x,ech                      : real;
begin
  teste_fichier_unix(nom_fichier_dif,ier);
  if (ier > 0)then  nom_fichier:='dummy.tmp' else nom_fichier:=nom_fichier_dif;
  theta_min_dif:=0;
  theta_max_dif:=0;
  assignFile(nomf,nom_fichier);
  reset(nomf);
  nb_raies_dif:=0;
  while not(eof(nomf)) do begin
    readln(nomf,x);
    if (x = 0)then continue;
    nb_raies_dif:=nb_raies_dif+1;
    theta_dif[nb_raies_dif]:=x;
    theta_dif_old[nb_raies_dif]:=theta_dif[nb_raies_dif];
    intensite_dif[nb_raies_dif]:=100;
  end;
  theta_min_dif:=theta_dif[1]-epsa;
  theta_max_dif:=theta_dif[nb_raies_dif]+epsa;
  if (theta_max_dif >= 180)then theta_max_dif:=179;
  closefile(nomf);
end;

Procedure lidif_winfit;
//---------------------
var
  nomf                       : TextFile;
  s42                        : string[42];
  s,s1,nom_fichier           : string;
  n,m,ier,i,j,no             : integer;
  x,ech                      : real;
  tableau                    : tab_reel;
  dump                       : array[1..132] of integer;
  chaine                     : array[1..50]of string;
begin
  theta_min_dif:=0;
  theta_max_dif:=0;
  teste_fichier_unix(nom_fichier_dif,ier);
  if (ier > 0)then  nom_fichier:='dummy.tmp' else nom_fichier:=nom_fichier_dif;
  assignFile(nomf,nom_fichier);
  reset(nomf);
  readln(nomf,s);
  i:=pos('Sample',s);
  j:= pos('Position',s);
  if (i = 0) or (j = 0) then begin
    erreur('It seems not a WINFIT file!');
    closefile(nomf);
    exit;
  end;
  m:=0;
  while not(eof(nomf)) do begin
    readln(nomf,s);
    m:=m+1;
    chaine[m]:=s;
  end;
  closefile(nomf);

  ymax:=0;
  for j:=1 to m do begin
    s:=chaine[j];
    s:=trim(s);
    for i:=1 to length(s) do if (ord(s[i]) = 9)then s[i]:=' ';
    i:=pos(' ',s);
    titre_dif:=copy(s,1,i-1);
    s:=copy(s,i,length(s)-i);
    s:=trim(s);
    dec(s,tableau,no,ier);
    if (ier > 0)then begin
      erreur('decode error');
      exit;
    end;
    theta_dif[j]:=tableau[1];
    theta_dif_old[j]:=tableau[1];
    intensite_dif[j]:=tableau[5];
    if (ymax < intensite_dif[j])then ymax:=intensite_dif[j];
  end;
  nb_raies_dif:=m;
  ech:=100/ymax;
  ymax_dif:=ymax;
  for i:=1 to nb_raies_dif do intensite_dif[i]:=intensite_dif[i]*ech;
  theta_min_dif:=theta_dif[1]-epsa;
  theta_max_dif:=theta_dif[nb_raies_dif]+epsa;
  if (theta_max_dif >= 180)then theta_max_dif:=179;
end;

procedure lidif_philips;
//----------------------
var
  i,j                                : integer;
  i2                                 : smallint;
  c2                                 : array[1..2]of char;
  c60                                : array[1..60] of char;
  c                                  : char;
  by                                       : byte;
  doub                                     : double;
  wo                                       : word;
  annee,mois,jour,ier                      : integer;
  x,y,w,bgrd,ech                           : real;
  bitset,significance                      : integer;
  s,s1,nom_fichier                         : string;
  nomf                                     : file;
begin
  lambda_dif:=0;
  lambda1_dif:=0;
  lambda1_dif:=0;
  ratio_dif:=0;
  anode_dif:='';
  theta_min_dif:=0;
  theta_max_dif:=0;
//Philips dif binaire  
     assignFile(nomf,nom_fichier_dif);
     reset(nomf,1);
     {No Revision}
      blockread(nomf,c2,2);                             //offset=2
      s:='';
      for i:=1 to 2 do begin
        s[i]:=c2[i];
      end;
      //Type of data file
      blockread(nomf,c2,2);                             //offset=4
      s:='';
      for i:=1 to 2 do begin
        s[i]:=c2[i];
      end;
      for i:=1 to 80 do blockread(nomf,c,1);            //offset=84
      //Diffractometer type
      blockread(nomf,by,1);                             //offset=85
      //Anode material
      blockread(nomf,by,1);                             //offset=86
      case by of
        0: anode_dif:='Cu';
        1: anode_dif:='Mo';
        2: anode_dif:='Co';
        3: anode_dif:='Fe';
        4: anode_dif:='Cr';
      end;
      for i:=1 to 8 do blockread(nomf,c,1);             //offset=94
      //lambda1
      blockread(nomf,doub,8);                           //offset=102
      lambda1_dif:=doub;
      //lambda2
      blockread(nomf,doub,8);                           //offset=110
      lambda2_dif:=doub;
      //Ratio
      blockread(nomf,doub,8);                           //offset=118
      ratio_dif:=doub;
      for i:=1 to 4 do blockread(nomf,c,1);             //offset=122
      //Date
      blockread(nomf,wo,2);                             //offset=124
      i:=wo;
      annee:=i div 512;
      i:=i-annee*512;
      mois:=i div 32;
      jour:=i-mois*32;
      s:='Date: ';
      str(jour:3,s1);
      s1:=trim(s1);
      s:=s+s1+'/';
      str(mois:2,s1);
      s1:=trim(s1);
      s:=s+s1+'/';
      str(annee:2,s1);
      s1:=trim(s1);
      s:=s+s1+'/';
      titre:=s;
      //Time
      blockread(nomf,wo,2);                                //offset=126

      //sample identification
      for i:=1 to 20 do blockread(nomf,c,1);               //      146
      s:='*';
      for i:=1 to 20 do s:=s+'*';
      blockread(nomf,c60,20);                              //      166
      for i:=1 to 20 do s[i]:=c60[i];
      titre_dif:=trim(s);

      for i:=1 to 38 do blockread(nomf,c,1);               //offset=204
      //nb of peaks in .DI file
      blockread(nomf,i2,2);                                //offset=206
      for i:=1 to 44 do blockread(nomf,c,1);               //offset=250
      //Measurements
      nb_raies_dif:=0;
      while not(eof(nomf)) do begin
        blockread(nomf,i2,2);
        x:=i2/200;
        blockread(nomf,i2,2);
        w:=i2/200;
        blockread(nomf,i2,2);
        y:=i2;
        blockread(nomf,i2,2);
        bgrd:=i2;
        blockread(nomf,i2,2);
        significance:=i2 div 10;
        blockread(nomf,i2,2);
        bitset:=i2;
        nb_raies_dif:=nb_raies_dif+1;
        theta_dif[nb_raies_dif]:=x;
        theta_dif_old[nb_raies_dif]:=x;
        intensite_dif[nb_raies_dif]:=y;
        if (ymax < y)then ymax:=y;
      end;
      CloseFile(nomf);
      ech:=100/ymax;
      ymax_dif:=ymax;
      for i:=1 to nb_raies_dif do intensite_dif[i]:=intensite_dif[i]*ech;
      theta_min_dif:=theta_dif[1]-epsa;
      theta_max_dif:=theta_dif[nb_raies_dif]+epsa;
end;

procedure lidif_crysfirecdt;
//--------------------------
var
  nomf                       : TextFile;
  s,nom_fichier              : string;
  n,ier,i,j,no               : integer;
  x,ech,shift                      : real;
  tableau                    : tab_reel;
  dump                       : array[1..132] of integer;
  //chaine                     : array[1..50]of string;
begin
  theta_min_dif:=0;
  theta_max_dif:=0;
  teste_fichier_unix(nom_fichier_dif,ier);
  if (ier > 0)then  nom_fichier:='dummy.tmp' else nom_fichier:=nom_fichier_dif;
  assignFile(nomf,nom_fichier);
  reset(nomf);
  for i:=1 to 4 do readln(nomf,s);
  delete(s,1,pos(',',s));
  delete(s,pos(',"',s),length(s)-pos(',"',s)+1);s:=trim(s);
  while (pos(',',s) > 0) do s[pos(',',s)]:=' ';
  dec(s,tableau,no,ier);
  shift:=0;
  shift:=tableau[7];
  n:=round(tableau[1]);
  lambda_dif:=tableau[6];
  lambda1_dif:=0;
  lambda2_dif:=0;
  ymax:=0;
  for j:=1 to n do begin
    readln(nomf,s);
    dec(s,tableau,no,ier);
    if (shift = 0)then begin
        intensite_dif[j]:=tableau[6];
    end else begin
        intensite_dif[j]:=tableau[1];
    end;
    theta_dif[j]:=tableau[5];
    theta_dif_old[j]:=tableau[5];
    if (ymax < intensite_dif[j])then ymax:=intensite_dif[j];
  end;
  closefile(nomf);
  nb_raies_dif:=n;

  if (ymax = 0)then begin
    for i:=1 to nb_raies_dif do intensite_dif[i]:=100;
    ymax:=100;
  end;
  ech:=100/ymax;
  ymax_dif:=ymax;
  for i:=1 to nb_raies_dif do intensite_dif[i]:=intensite_dif[i]*ech;
  theta_min_dif:=theta_dif[1]-epsa;
  theta_max_dif:=theta_dif[nb_raies_dif]+epsa;
  if (theta_max_dif >= 180)then theta_max_dif:=179;
end;

//=============================================================================
procedure liraw_brucker;{
------------------------}
var
  nb_total_bytes,step_count          : integer;
  dtheta_depart,step_size            : real;
  xmin,xmax                          : real;

  i,longueur_header                  : integer;
  i2                                 : smallint;
  i4                                 : longint;
  c4                                 : array[1..4] of char;
  c32                                : array[1..32] of char;
  c                                  : char;
  x,y                                : single;
  x8,wl,wl1,wl2,ratio,stp_si,th_dep  : double;
  s                                  : string;
  nomf                               : file;
  ech                                : real;
  bool                               : boolean;

begin
  lambda_raw:=0;
  lambda1_raw:=0;
  lambda1_raw:=0;
  ratio_raw:=0;
  anode_raw:='';
  theta_min_raw:=0;
  theta_max_raw:=0;
  titre_raw:='';
//Fichier Raw binaire
  assignFile(nomf,nom_fichier_raw);
  reset(nomf,1);
  {Fichier RAW ou RAW2 ou RAW1?}
  blockread(nomf,c4,4);
  s:='';
  for i:=1 to 4 do begin
    s[i]:=c4[i];
  end;

  {--------------------Lecture de fichier type RAW2----------------------------}
  s:=trimright(s);
  if (s = 'RAW2')then begin
    {nb. de tranches}
    blockread(nomf,i,4);                                       //offset 8
    //Sample name
    blockread(nomf,c32,32);                                    //      40
    s:='*';
    for i:=1 to 32 do s:=s+'*';
    for i:=1 to 32 do s[i]:=c32[i];
    titre_raw:=s+' (RAW2)';
    for i:=1 to 148 do blockread(nomf,c,1);                    //offset 188
    blockread(nomf,c4,2);                                      //offset 190
    anode_raw:='****';
    for i:=1 to 2 do anode_raw[i]:=c4[i];
    {lambda1}
    blockread(nomf,x,4);
    lambda1_raw:=x;
    {Lambda2}
    blockread(nomf,x,4);
    lambda2_raw:=x;
    {Ratio lambda2/lambda1}
    blockread(nomf,x,4);                                      //offset 202
    ratio_raw:=x;
    if (lambda2_raw <> 0)then
    lambda_raw:=(lambda1_raw+ratio_raw*lambda2_raw)/(1+ratio_raw)
    else lambda_raw:=lambda1_raw;
    for i:=1 to 54 do blockread(nomf,c,1);

//dimension header
    blockread(nomf,i2,2);
    nb_total_bytes:=i2;
//step_count
    blockread(nomf,i2,2);
    step_count:=i2;

//------------------------------------------------------------------------------
//Modif janvier 2001 dtection du scan mode
//stepping drive
    blockread(nomf,i4,4);
//Step_mode
    blockread(nomf,i2,2);
    if (i2 mod 2 = 0)then bool:=false else bool:=true; //pair:step, impair continuous
//------------------------------------------------------------------------------

    for i:=1 to 2 do blockread(nomf,c,1);
    {step_size}
    blockread(nomf,x,4);
    step_size:=x;
    {2thta dpart}
    blockread(nomf,x,4);
    dtheta_depart:=x;
    if bool then dtheta_depart:=dtheta_depart+step_size/2;
    for i:=1 to 40 do blockread(nomf,c,1);
    {enregistrements supplmentaires}
    if (nb_total_bytes > 60)then begin
      for i:=1 to nb_total_bytes-60 do blockread(nomf,c,1);
    end;
    {profil}
    ymax:=0;
    ymin:=1000000;
    nb_raies_raw:=step_count;
    xmax:=0;
    xmin:=180;
    for i:=1 to step_count do begin
      blockread(nomf,y,4);
      x:=dtheta_depart+(i-1)*step_size;
      x_theta[i]:=x;
      y_intensite[i]:=y;
      if (xmax < x)then xmax:=x;
      if (xmin > x)then xmin:=x;
      if(ymax < y)then ymax:=y;
      if(ymin > y)then ymin:=y;
    end;
    theta_min_raw:=xmin;
    theta_max_raw:=xmax;
  //end;

{---------------------Lecture de fichier type RAW------------------------------}
  end else if (s = 'RAW') then begin        //Ne donne ni lambda moy ni anode
    anode_raw:='?';
    {step_count}
    blockread(nomf,i4,4);                            //8
    step_count:=i4;
    for i:=1 to 4 do blockread(nomf,c,1);            //offset 12
    {step_size}
    blockread(nomf,x,4);                             //16
    step_size:=x;

//------------------------------------------------------------------------------
//Modif janvier 2001 dtection du scan mode
    blockread(nomf,i4,4);                             //20
    bool:=false;
    if (i4 = 2048) then bool:=true;
//------------------------------------------------------------------------------
    for i:=1 to 4 do blockread(nomf,c,1);            //24
    {dtheta_depart}
    blockread(nomf,x,4);                             //28
    dtheta_depart:=x;
    if bool then dtheta_depart:=dtheta_depart+step_size/2;
    for i:=1 to 12 do blockread(nomf,c,1);           //40

    //titre echantillon
    blockread(nomf,c32,32);                          //72
    s:='*';for i:=1 to 32 do s:=s+'*';
    for i:=1 to 32 do s[i]:=c32[i];
    titre_raw:=s+' (RAW)';

    {Lecture lambda}
    blockread(nomf,x,4);                              //76
    lambda1_raw:=x;
    {lambda2}
    blockread(nomf,x,4);                              //80
    lambda2_raw:=x;
    if (lambda2_raw > 0)then lambda_raw:=(lambda1_raw+0.50*lambda2_raw)/1.5
    else lambda_raw:=lambda1_raw;
    for i:=1 to 72 do blockread(nomf,c,1);
    {Nb. de tranches supplmentaires}
    blockread(nomf,i4,4);
    {profil}
    nb_raies_raw:=step_count;
    ymax:=0;
    ymin:=1000000;
    xmax:=0;
    xmin:=180;
    for i:=1 to step_count do begin
      blockread(nomf,y,4);
      x:=dtheta_depart+(i-1)*step_size;
      if (xmax < x)then xmax:=x;
      if (xmin > x)then xmin:=x;
      if(y > ymax)then ymax:=y;
      if(y < ymin)then ymin:=y;
      x_theta[i]:=x;
      y_intensite[i]:=y;
    end;
    theta_min_raw:=xmin;
    theta_max_raw:=xmax;
    if (lambda_raw = 0)then begin
      if (lambda2_raw > 0)then
      lambda_raw:=(lambda1_raw+ratio_raw*lambda2_raw)/(1+ratio_raw)
      else lambda_raw:=lambda1_raw;
    end;
  //end;
//*************************************RAW1*************************************
  end else if (s = 'RAW1')then begin      // donne lambda moy anode ratio
    for i:=1 to 326 do blockread(nomf,c,1);        //offset 326
    blockread(nomf,c32,32);                        //       358
    s:='********************************';
    for i:=1 to 32 do s[i]:=c32[i];
    titre_raw:=s+' (RAW1)';
    for i:=1 to 246 do blockread(nomf,c,1);         //       604
    blockread(nomf,c4,4);                          //Offset 612
    anode_raw:='**';
    for i:=1 to 2 do anode_raw[i]:=c4[i];
    blockread(nomf,c4,4);                          //Offset 616
    blockread(nomf,wl,8);                          //offset 624
    blockread(nomf,wl1,8);                         //offset 632
    blockread(nomf,wl2,8);                         //offset 640
    blockread(nomf,x8,8);                          //offset 648
    blockread(nomf,ratio,8);                       //offset 656
    for i:=1 to 56 do blockread(nomf,c,1);         //offset 712 fin du 1er header
//******************************************
    for i:=1 to 4 do blockread(nomf,c,1);
    blockread(nomf,i4,4);                         // offset 8
    nb_raies_raw:=i4;
    for i:=1 to 8 do blockread(nomf,c,1);         // offset 16
    blockread(nomf,th_dep,8);                     // offset 24
    for i:=1 to 144 do blockread(nomf,c,1);       //offset 168
//------------------------------------------------------------------------------
//Modif du 21 janvier 20001: dtection du scan mode
    blockread(nomf,i4,4);                         //offset 172
    if (i4 = 1)then bool:=true else bool:=false;
    for i:=1 to 4 do blockread(nomf,c,1);         //offset 176
//------------------------------------------------------------------------------
    blockread(nomf,stp_si,8);                     //offset 184
    if bool then th_dep:=th_dep+stp_si/2;
    for i:=1 to 72 do blockread(nomf,c,1);        //offset 256
    blockread(nomf,i4,4);                         // offset260
    longueur_header:=i4;
    for i:=1 to 44 do blockread(nomf,c,1);        //offset 304

    if (longueur_header > 0)then                 //Enregistrements supplmentaires
    for i:=1 to longueur_header do blockread(nomf,c,1);

    ymax:=-10000;
    ymin:=1000000;
    nb_raies_raw:=0;
    //For i:=1 to nb_raies_raw do begin
    while not eof(nomf) do begin
      nb_raies_raw:=nb_raies_raw+1;
      x_theta[nb_raies_raw]:=th_dep+(nb_raies_raw-1)*stp_si;
      blockread(nomf, y_intensite[nb_raies_raw],4);
      if (ymax < y_intensite[nb_raies_raw])then ymax:=y_intensite[nb_raies_raw];
      if (ymin > y_intensite[nb_raies_raw])then ymin:=y_intensite[nb_raies_raw];
    end;
    lambda1_raw:=wl1;
    lambda2_raw:=wl2;
    lambda_raw:=wl;
    theta_min_raw:=x_theta[1];
    theta_max_raw:=x_theta[nb_raies_raw];
  end else begin
    erreur('Unknown file type');
    exit;
  end;

  closefile(nomf);
  ech:=100/(ymax-ymin);
  ymax_raw:=ymax;
  ymin_raw:=ymin;
  for i:=1 to nb_raies_raw do y_intensite[i]:=(y_intensite[i]-ymin)*ech;
end;
(*
procedure liraw_brucker2;{
------------------------}
var
  nb_total_bytes,step_count          : integer;
  dtheta_depart,step_size            : real;
  xmin,xmax                          : real;

  i,longueur_header                  : integer;
  i2                                 : smallint;
  i4                                 : longint;
  c4                                 : array[1..4] of char;
  c32                                : array[1..32] of char;
  c                                  : char;
  x,y                                : single;
  x8,wl,wl1,wl2,ratio,stp_si,th_dep  : double;
  s                                  : string;
  nomf                               : file;
  ech                                : real;

begin
  lambda_raw:=0;
  lambda1_raw:=0;
  lambda1_raw:=0;
  ratio_raw:=0;
  anode_raw:='';
  theta_min_raw:=0;
  theta_max_raw:=0;
  titre_raw:='';
//Fichier Raw binaire
  assignFile(nomf,nom_fichier_raw);
  reset(nomf,1);
  {Fichier RAW ou RAW2?}
  blockread(nomf,c4,4);
  s:='';
  for i:=1 to 4 do begin
    s[i]:=c4[i];
  end;

  {--------------------Lecture de fichier type RAW2----------------------------}
  s:=trimright(s);
  if (s = 'RAW2')then begin
    {nb. de tranches}
    blockread(nomf,i,4);                                       //offset 8
    //Sample name
    blockread(nomf,c32,32);                                    //      40
    s:='*';
    for i:=1 to 32 do s:=s+'*';
    for i:=1 to 32 do s[i]:=c32[i];
    titre_raw:=s+' (RAW2)';
    for i:=1 to 148 do blockread(nomf,c,1);                    //offset 188
    blockread(nomf,c4,2);                                      //offset 190
    anode_raw:='****';
    for i:=1 to 2 do anode_raw[i]:=c4[i];
    {lambda1}
    blockread(nomf,x,4);
    lambda1_raw:=x;
    {Lambda2}
    blockread(nomf,x,4);
    lambda2_raw:=x;
    {Ratio lambda2/lambda1}
    blockread(nomf,x,4);                                      //offset 202
    ratio_raw:=x;
    if (lambda2_raw <> 0)then
    lambda_raw:=(lambda1_raw+ratio_raw*lambda2_raw)/(1+ratio_raw)
    else lambda_raw:=lambda1_raw;
    for i:=1 to 54 do blockread(nomf,c,1);
    {dimension header}
    blockread(nomf,i2,2);
    nb_total_bytes:=i2;
    {step_count}
    blockread(nomf,i2,2);
    step_count:=i2;
    for i:=1 to 8 do blockread(nomf,c,1);
    {step_size}
    blockread(nomf,x,4);
    step_size:=x;
    {2thta dpart}
    blockread(nomf,x,4);
    dtheta_depart:=x;
    for i:=1 to 40 do blockread(nomf,c,1);
    {enregistrements supplmentaires}
    if (nb_total_bytes > 60)then begin
      for i:=1 to nb_total_bytes-60 do blockread(nomf,c,1);
    end;
    {profil}
    ymax:=0;
    ymin:=1000000;
    nb_raies_raw:=step_count;
    xmax:=0;
    xmin:=180;
    for i:=1 to step_count do begin
      blockread(nomf,y,4);
      x:=dtheta_depart+(i-1)*step_size;
      x_theta[i]:=x;
      y_intensite[i]:=y;
      if (xmax < x)then xmax:=x;
      if (xmin > x)then xmin:=x;
      if(ymax < y)then ymax:=y;
      if(ymin > y)then ymin:=y;
    end;
    theta_min_raw:=xmin;
    theta_max_raw:=xmax;
  //end;

{---------------------Lecture de fichier type RAW------------------------------}
  end else if (s = 'RAW') then begin        //Ne donne ni lambda moy ni anode
    anode_raw:='?';
    {step_count}
    blockread(nomf,i4,4);                            //8
    step_count:=i4;
    for i:=1 to 4 do blockread(nomf,c,1);            //offset 12
    {step_size}
    blockread(nomf,x,4);                             //16
    step_size:=x;
    for i:=1 to 8 do blockread(nomf,c,1);            //24
    {dtheta_depart}
    blockread(nomf,x,4);                             //28
    dtheta_depart:=x;
    for i:=1 to 12 do blockread(nomf,c,1);           //40

    //titre echantillon
    blockread(nomf,c32,32);                          //72
    s:='*';for i:=1 to 32 do s:=s+'*';
    for i:=1 to 32 do s[i]:=c32[i];
    titre_raw:=s+' (RAW)';

    {Lecture lambda}
    blockread(nomf,x,4);                              //76
    lambda1_raw:=x;
    {lambda2}
    blockread(nomf,x,4);                              //80
    lambda2_raw:=x;
    if (lambda2_raw > 0)then lambda_raw:=(lambda1_raw+0.50*lambda2_raw)/1.5
    else lambda_raw:=lambda1_raw;
    for i:=1 to 72 do blockread(nomf,c,1);
    {Nb. de tranches supplmentaires}
    blockread(nomf,i4,4);
    {profil}
    nb_raies_raw:=step_count;
    ymax:=0;
    ymin:=1000000;
    xmax:=0;
    xmin:=180;
    for i:=1 to step_count do begin
      blockread(nomf,y,4);
      x:=dtheta_depart+(i-1)*step_size;
      if (xmax < x)then xmax:=x;
      if (xmin > x)then xmin:=x;
      if(y > ymax)then ymax:=y;
      if(y < ymin)then ymin:=y;
      x_theta[i]:=x;
      y_intensite[i]:=y;
    end;
    theta_min_raw:=xmin;
    theta_max_raw:=xmax;
    if (lambda_raw = 0)then begin
      if (lambda2_raw > 0)then
      lambda_raw:=(lambda1_raw+ratio_raw*lambda2_raw)/(1+ratio_raw)
      else lambda_raw:=lambda1_raw;
    end;
  //end;

  end else if (s = 'RAW1')then begin      // donne lambda moy anode ratio
    for i:=1 to 326 do blockread(nomf,c,1);        //offset 326
    blockread(nomf,c32,32);                        //       358
    s:='********************************';
    for i:=1 to 32 do s[i]:=c32[i];
    titre_raw:=s+' (RAW1)';
    for i:=1 to 246 do blockread(nomf,c,1);         //       604
    blockread(nomf,c4,4);                          //Offset 612
    anode_raw:='**';
    for i:=1 to 2 do anode_raw[i]:=c4[i];
    blockread(nomf,c4,4);                          //Offset 616
    blockread(nomf,wl,8);                          //offset 624
    blockread(nomf,wl1,8);                         //offset 632
    blockread(nomf,wl2,8);                         //offset 640
    blockread(nomf,x8,8);                          //offset 648
    blockread(nomf,ratio,8);                       //offset 656
    for i:=1 to 56 do blockread(nomf,c,1);         //offset 712 fin du 1er header

    for i:=1 to 4 do blockread(nomf,c,1);
    blockread(nomf,i4,4);                         // offset 8
    nb_raies_raw:=i4;
    for i:=1 to 8 do blockread(nomf,c,1);         // offset 16
    blockread(nomf,th_dep,8);                     // offset 24
    for i:=1 to 152 do blockread(nomf,c,1);       //offset 176
    blockread(nomf,stp_si,8);                     //offset 184
    for i:=1 to 72 do blockread(nomf,c,1);        //offset 256
    blockread(nomf,i4,4);                         // offset260
    longueur_header:=i4;
    for i:=1 to 44 do blockread(nomf,c,1);        //offset 304

    if (longueur_header > 0)then                 //Enregistrements supplmentaires
    for i:=1 to longueur_header do blockread(nomf,c,1);

    ymax:=-10000;
    ymin:=1000000;
    nb_raies_raw:=0;
    //For i:=1 to nb_raies_raw do begin
    while not eof(nomf) do begin
      nb_raies_raw:=nb_raies_raw+1;
      x_theta[nb_raies_raw]:=th_dep+(nb_raies_raw-1)*stp_si;
      blockread(nomf, y_intensite[nb_raies_raw],4);
      if (ymax < y_intensite[nb_raies_raw])then ymax:=y_intensite[nb_raies_raw];
      if (ymin > y_intensite[nb_raies_raw])then ymin:=y_intensite[nb_raies_raw];
    end;
    lambda1_raw:=wl1;
    lambda2_raw:=wl2;
    lambda_raw:=wl;
    theta_min_raw:=x_theta[1];
    theta_max_raw:=x_theta[nb_raies_raw];
  end else begin
    erreur('Unknown file type');
    exit;
  end;

  closefile(nomf);
  ech:=100/(ymax-ymin);
  ymax_raw:=ymax;
  ymin_raw:=ymin;
  for i:=1 to nb_raies_raw do y_intensite[i]:=(y_intensite[i]-ymin)*ech;
end;
     *)
     
//Lecture fichiers Rietveld (*.dat)
procedure liraw_rietveld;
//-----------------------
const
  type_anode : array[1..5] of string[2]= ('Mo','Cu','Co','Fe','Cr');
  wl1 : array[1..5]of real = (0.70930,1.54056,1.78897,1.93339,2.28970);
  wl2 : array[1..5]of real = (0.71359,1.54439,1.79285,1.93730,2.29361);
  wl  : array[1..5]of real = (0.71070,1.54180,1.79020,1.93604,2.29090);
var
  i,j,n,ier                : integer;
  xmin,xmax,x,pas,ech      : real;
  nomf                     : TextFile;
  s,s1,nom_fichier         : string;
  ligne                    : tab_reel;
  nb                       : integer;
  label 1;
begin
  lambda_raw:=0;
  lambda1_raw:=0;
  lambda1_raw:=0;
  ratio_raw:=0;
  anode_raw:='';
  theta_min_raw:=0;
  theta_max_raw:=0;

  teste_fichier_unix(nom_fichier_raw,ier);
  if (ier > 0)then  nom_fichier:='dummy.tmp' else nom_fichier:=nom_fichier_raw;
  assignFile(nomf,nom_fichier);
  reset(nomf);

  //Lecture du header
  readln(nomf,s);
  if (s = '')then begin
    readln(nomf);
    readln(nomf);
    readln(nomf);
    goto 1
  end;
  if (pos('SampleIdent',s) = 0)then begin
    erreur('Error while reading the wavelength in Rietvelf File');
    closeFile(nomf);
    exit;
  end else begin
    i:=pos('SampleIdent',s)+12;
    j:=pos('DataFileName',s);
    titre_raw:=copy(s,i,j-i-1);
    titre_raw:=trim(titre_raw);
  end;
  readln(nomf);
  readln(nomf,s);
  n:=pos('Alpha1',s);
  if (n > 0)then begin
    delete(s,1,n+length('alpha1'));
    s:=trim(s);
    if (pos(' ',s) > 0)then s1:=copy(s,1,pos(' ',s)-1)else s1:=s;
    val(s1,x,ier);
    if (ier = 0)then lambda1_raw:=x else lambda1_raw:=0;
  end;
  n:=pos('Alpha2',s);
  if (n > 0)then begin
    delete(s,1,n+length('alpha2'));
    s:=trim(s);
    if (pos(' ',s) > 0)then s1:=copy(s,1,pos(' ',s)-1)else s1:=s;
    val(s1,x,ier);
    if (ier = 0)then lambda2_raw:=x else lambda2_raw:=0;
  end;
  n:=pos('Ratio',s);
  if (n > 0)then begin
    delete(s,1,n+length('Ratio'));
    s:=trim(s);
    if (pos(' ',s) > 0)then s1:=copy(s,1,pos(' ',s)-1)else s1:=s;
    val(s1,x,ier);
    if (ier = 0)then ratio_raw:=x else ratio_raw:=0;
  end;
  lambda_raw:=(lambda1_raw+ratio_raw*lambda2_raw)/(1+ratio_raw);
  n:=pos('Alpha2',s);
  if (n > 0)then begin
    delete(s,1,n+length('alpha1'));
    s:=trim(s);
    if (pos(' ',s) > 0)then s1:=copy(s,1,pos(' ',s)-1)else s1:=s;
    val(s1,x,ier);
    if (ier = 0)then lambda2_raw:=x else lambda2_raw:=0;
  end;
  readln(nomf);

 //Lecture theta_min, pas, theta_max
1:  readln(nomf,xmin,pas,xmax);
  n:=0;
  ymax:=0;
  ymin:=1000000;
  while not(eof(nomf)) do begin
    readln(nomf,s);
    dec(s,ligne,nb,ier);
    if (ier > 0)then begin
      erreur('Read error!');
      exit;
    end;
    for i:=1 to nb do begin
      n:=n+1;
      y_intensite[n]:=ligne[i];
      x_theta[n]:=xmin+(n-1)*pas;
      if (y_intensite[n] > ymax)then ymax:=y_intensite[n];
      if (y_intensite[n] < ymin)then ymin:=y_intensite[n];
    end;
  end;
  nb_raies_raw:=n;
  ech:=100/(ymax-ymin);
  ymax_raw:=ymax;
  ymin_raw:=ymin;
  for i:=1 to nb_raies_raw do y_intensite[i]:=(y_intensite[i]-ymin)*ech;
  theta_min_raw:=xmin;
  theta_max_raw:=xmax;
  //wl1 et/ou wl2 n'ont pas t lus
  if (lambda1_raw = 0) or (lambda2_raw = 0) and (anode_raw <> '')then begin
    s1:=anode_raw;s1:=uppercase(s1);
    for i:=1 to 5 do begin
      s:=type_anode[i];s:=uppercase(s);
      if (s = s1)then begin
        lambda1_raw:=wl1[i];
        lambda2_raw:=wl2[i];
        if (ratio_raw = 0)then ratio_raw:=0.50;
        break;
      end;
    end;
  end;
  closefile(nomf);
end;

procedure liraw_cpi;
//------------------
const
  type_anode : array[1..5] of string[2]= ('Mo','Cu','Co','Fe','Cr');
  wl1 : array[1..5]of real = (0.70930,1.54056,1.78897,1.93339,2.28970);
  wl2 : array[1..5]of real = (0.71359,1.54439,1.79285,1.93730,2.29361);
  wl  : array[1..5]of real = (0.71070,1.54180,1.79020,1.93604,2.29090);
var
  i,n,ier                  : integer;
  xmin,xmax,x,pas,ech      : real;
  nomf                     : TextFile;
  s,s1,nom_fichier         : string;
begin
  lambda_raw:=0;
  lambda1_raw:=0;
  lambda1_raw:=0;
  ratio_raw:=0;
  anode_raw:='';
  theta_min_raw:=0;
  theta_max_raw:=0;

  teste_fichier_unix(nom_fichier_raw,ier);
  if (ier > 0)then  nom_fichier:='dummy.tmp' else nom_fichier:=nom_fichier_raw;
  assignFile(nomf,nom_fichier);
  reset(nomf);
  readln(nomf);
  readln(nomf,xmin);
  readln(nomf,xmax);
  readln(nomf,pas);
  readln(nomf,anode_raw);
  readln(nomf,lambda_raw);
  for i:=1 to 2 do readln(nomf);
  readln(nomf,s);
  titre_raw:=copy(s,12,length(s)-12);
  titre_raw:=trim(titre_raw);
  readln(nomf);
  ymax:=0;
  ymin:=100000;
  n:=0;
  while not(eof(nomf)) do begin
    read(nomf,x);
    n:=n+1;
    y_intensite[n]:=x;
    if (x > ymax)then ymax:=x;
    if (x < ymin)then ymin:=x;
    x_theta[n]:=xmin+(n-1)*pas;
  end;
  nb_raies_raw:=n;
  ech:=100/(ymax-ymin);
  ymax_raw:=ymax;
  ymin_raw:=ymin ;
  for i:=1 to n do y_intensite[i]:=(y_intensite[i]-ymin)*ech;
  if (nb_raies_dif = 0) and (nb_raies_indx = 0)then begin
  theta_min_raw:=xmin;
  theta_max_raw:=xmax;

  //wl1 et/ou wl2 n'ont pas t lus
  if (lambda1_raw = 0) or (lambda2_raw = 0) and (anode_raw <> '')then begin
    s1:=anode_raw;s1:=uppercase(s1);
    for i:=1 to 5 do begin
      s:=type_anode[i];s:=uppercase(s);
      if (s = s1)then begin
        lambda1_raw:=wl1[i];
        lambda2_raw:=wl2[i];
        if (ratio_raw = 0)then ratio_raw:=0.50;
        break;
      end;
    end;
  end;
 end;
 closefile(nomf);
end;

//Lecture de fichier profil philips (*.rd)
procedure liraw_philips;
//----------------------
var
  i,ier                              : integer;
  i2                                 : smallint;
  c2                                 : array[1..2]of char;
  c60                                : array[1..60] of char;
  c                                  : char;
  by                                 : byte;
  doub                               : double;
  bool                               : boolean;
  xmin,xmax,pas,ech                  : real;
  nomf                               : file;
  version                            : string[2];
  s,nom_fichier                      : string;
begin
  lambda_raw:=0;
  lambda1_raw:=0;
  lambda1_raw:=0;
  ratio_raw:=0;
  anode_raw:='';
  theta_min_raw:=0;
  theta_max_raw:=0;
//Fichier Philips raw binaire
  assignFile(nomf,nom_fichier_raw);
  reset(nomf,1);
  {Revision No}
  blockread(nomf,c2,2);                                  //offset=2
  s:='';
  for i:=1 to 2 do begin
    s[i]:=c2[i];
  end;
  version:=s;
  //Type of data file
  blockread(nomf,c2,2);                                   //offset=4
  s:='';
  for i:=1 to 2 do s[i]:=c2[i];
  if (s <> 'RD')then begin
    erreur('It seems not to be a .RD Philips file');
    exit;
  end;
      for i:=1 to 81 do blockread(nomf,c,1);               //offset=85
      blockread(nomf,by,1);                               //offset=86
      case by of
        0: anode_raw:='Cu';
        1: anode_raw:='Mo';
        2: anode_raw:='Co';
        3: anode_raw:='Fe';
        4: anode_raw:='Cr';
      end;
      for i:=1 to 8 do blockread(nomf,c,1);               //offset=94
      //lambda1
      blockread(nomf,doub,8);                             //offset=102
      lambda1_raw:=doub;
      //lambda2
      blockread(nomf,doub,8);                             //offset=110
      lambda2_raw:=doub;
      //Ratio
      blockread(nomf,doub,8);                             //offset=118
      blockread(nomf,c,1);                                 //offset=119
      blockread(nomf,c,1);                                 //offset=120
      blockread(nomf,bool,1);                             //offset=121

      //sample identification
      for i:=1 to 25 do blockread(nomf,c,1);               //      146
      s:='*';
      for i:=1 to 20 do s:=s+'*';
      blockread(nomf,c60,20);                              //      166
      for i:=1 to 20 do s[i]:=c60[i];
      titre_raw:=trim(s);

      ratio_raw:=doub;
      for i:=1 to 48 do blockread(nomf,c,1);               //offset 214
     //StepSize
      blockread(nomf,doub,8);                              //offset=222
      pas:=doub;
      //Start angle
      blockread(nomf,doub,8);                               //offset=230
      xmin:=doub;
      if bool then xmin:=xmin+pas/2;
      //Final angle
      blockread(nomf,doub,8);                              //offset=238
      xmax:=doub;
      if (version = 'V5')then for i:=1 to 572 do blockread(nomf,c,1)
      else for i:=1 to 12 do blockread(nomf,c,1);          //offset=250 ou 810
//    nb_raies_raw:=round((xmax-xmin)/pas);
      ymax:=0;
      ymin:=1000000;
      nb_raies_raw:=0;
      //for i:=1 to nb_raies_raw do begin
      while not(eof(nomf)) do begin
        blockread(nomf,i2,2);
        nb_raies_raw:=nb_raies_raw+1;
        x_theta[nb_raies_raw]:=xmin+(nb_raies_raw-1)*pas;
        y_intensite[nb_raies_raw]:=sqr(i2*0.1);
        if (ymax < y_intensite[nb_raies_raw])then ymax:=y_intensite[nb_raies_raw];
        if (ymin > y_intensite[nb_raies_raw])then ymin:=y_intensite[nb_raies_raw];
      end;
    CloseFile(nomf);
    ech:=100/(ymax-ymin);
    ymax_raw:=ymax;
    ymin_raw:=ymin;
    for i:=1 to nb_raies_raw do y_intensite[i]:=(y_intensite[i]-ymin)*ech;
    lambda_raw:=(lambda1_raw+ratio_raw*lambda2_raw)/(1+ratio_raw);
    theta_min_raw:=xmin;
    theta_max_raw:=xmax;
end;
(*
procedure liraw_philips2;
//----------------------
var
  i,ier                              : integer;
  i2                                 : smallint;
  c2                                 : array[1..2]of char;
  c60                                : array[1..60] of char;
  c                                  : char;
  by                                 : byte;
  doub                               : double;
  xmin,xmax,pas,ech                  : real;
  nomf                               : file;
  version                            : string[2];
  s,nom_fichier                      : string;
begin
  lambda_raw:=0;
  lambda1_raw:=0;
  lambda1_raw:=0;
  ratio_raw:=0;
  anode_raw:='';
  theta_min_raw:=0;
  theta_max_raw:=0;
//Fichier Philips raw binaire
  assignFile(nomf,nom_fichier_raw);
  reset(nomf,1);
  {Revision No}
  blockread(nomf,c2,2);                                  //offset=2
  s:='';
  for i:=1 to 2 do begin
    s[i]:=c2[i];
  end;
  version:=s;
  //Type of data file
  blockread(nomf,c2,2);                                   //offset=4
  s:='';
  for i:=1 to 2 do s[i]:=c2[i];
  if (s <> 'RD')then begin
    erreur('It seems not to be a .RD Philips file');
    exit;
  end;
      for i:=1 to 81 do blockread(nomf,c,1);               //offset=85
      blockread(nomf,by,1);                               //offset=86
      case by of
        0: anode_raw:='Cu';
        1: anode_raw:='Mo';
        2: anode_raw:='Co';
        3: anode_raw:='Fe';
        4: anode_raw:='Cr';
      end;
      for i:=1 to 8 do blockread(nomf,c,1);               //offset=94
      //lambda1
      blockread(nomf,doub,8);                             //offset=102
      lambda1_raw:=doub;
      //lambda2
      blockread(nomf,doub,8);                             //offset=110
      lambda2_raw:=doub;
      //Ratio
      blockread(nomf,doub,8);                             //offset=118

      //sample identification
      for i:=1 to 28 do blockread(nomf,c,1);               //      146
      s:='*';
      for i:=1 to 20 do s:=s+'*';
      blockread(nomf,c60,20);                              //      166
      for i:=1 to 20 do s[i]:=c60[i];
      titre_raw:=trim(s);

      ratio_raw:=doub;
      for i:=1 to 48 do blockread(nomf,c,1);               //offset 214
     //StepSize
      blockread(nomf,doub,8);                              //offset=222
      pas:=doub;
      //Start angle
      blockread(nomf,doub,8);                               //offset=230
      xmin:=doub;
      //Final angle
      blockread(nomf,doub,8);                              //offset=238
      xmax:=doub;
      if (version = 'V5')then for i:=1 to 572 do blockread(nomf,c,1)
      else for i:=1 to 12 do blockread(nomf,c,1);          //offset=250 ou 810
      nb_raies_raw:=round((xmax-xmin)/pas)+1;
      ymax:=0;
      ymin:=1000000;
      for i:=1 to nb_raies_raw do begin
        x_theta[i]:=xmin+(i-1)*pas;
        blockread(nomf,i2,2);
        y_intensite[i]:=sqr(i2*0.1);
        if (ymax < y_intensite[i])then ymax:=y_intensite[i];
        if (ymin > y_intensite[i])then ymin:=y_intensite[i];
      end;
    CloseFile(nomf);
    ech:=100/(ymax-ymin);
    ymax_raw:=ymax;
    ymin_raw:=ymin;
    for i:=1 to nb_raies_raw do y_intensite[i]:=(y_intensite[i]-ymin)*ech;
    lambda_raw:=(lambda1_raw+ratio_raw*lambda2_raw)/(1+ratio_raw);
    theta_min_raw:=xmin;
    theta_max_raw:=xmax;
end;
      *)

procedure ecrit_dif;
//-----------------
var
  nb_total_bytes,step_count,nb_tranches: integer;
  dtheta_depart,step_size              : real;

  i,j,ier                            : integer;
  i2                                 : smallint;
  c4                                 : array[1..4]of char;
  c                                  : char;
  x,y                                : single;
  r8                                 : double;

  s                                  : string;
  nomf                               : file;

begin
  assignFile(nomf,nom_fichier_dif);
  rewrite(nomf,1);
  s:='DIF2';
  for i:=1 to 4 do c4[i]:=s[i];
  blockwrite(nomf,c4,4);
  {nr}
  i2:=1;
  blockwrite(nomf,i2,2);
  c:=' ';
  for i:=1 to 184 do blockwrite(nomf,c,1);
  {longueur d'onde}
  x:=lambda;
  blockwrite(nomf,x,4);
  {lambda2}
  blockwrite(nomf,x,4);
  {ratio}
  x:=1;
  blockwrite(nomf,x,4);
  for i:=1 to 54 do blockwrite(nomf,c,1);
  {dimension du header}
  i2:=96;
  blockwrite(nomf,i2,2);
  for i:=1 to 4 do blockwrite(nomf,c,1);
  {nb. de pics}
  i2:=nb_raies_dif;
  blockwrite(nomf,i2,2);
  for i:=1 to 10 do blockwrite(nomf,c,1);
  {step_size}
  x:=0;
  blockwrite(nomf,x,4);
  {2 thta de dpart}
   x:=theta_min;
  blockwrite(nomf,x,4);
  dtheta_depart:=x;
  for i:=1 to 70 do blockwrite(nomf,c,1);
  for i:=1 to nb_raies_dif do begin
    x:=theta_dif[i];
    blockwrite(nomf,x,4);
    x:=intensite_dif[i];
    blockwrite(nomf,x,4);
    for j:=1 to 8 do blockwrite(nomf,c,1);
  end;
  closefile(nomf);
  showmessage('The peak positions were saved in the file '+nom_fichier_dif);
end;

procedure ecrit_prn;
//------------------
var
  nomf                : TextFile;
  i                   : integer;
begin
  AssignFile(nomf,nom_fichier_dif);
  rewrite(nomf);
  for i:=1 to nb_raies_dif do writeln(nomf,theta_dif[i]:8:3);
  closefile(nomf);
end;

procedure ecrit_sim;
//-------------------
var
  s                   : string;
  nomf                : File;
  nom                 : textfile;
  c4                  : array[1..4] of char;
  tab                 : tab_car;
  i2                  : integer;
  i                   : integer;
  r4                  : single;
  r8                  : double;
begin
     assignFile(nomf,nom_fichier_sim);
     rewrite(nomf,1);
// Header fichier
     s:='RAW2';
     chaine_to_car(s,tab,4);
     blockwrite(nomf,tab,4);
     // Nombre de tranches
     i2:=1;
     blockwrite(nomf,i2,2);
     // "spare reserved" + Nom de base de l'chantillon
     s:='  '+titre;
     chaine_to_car(s,tab,34);
     blockwrite(nomf,tab,34);
     // Commentaires
     s:='from CELREF';
     chaine_to_car(s,tab,128);
     blockwrite(nomf,tab,128);
     // Date
     s:=DateToStr(date);
     chaine_to_car(s,tab,20);
     blockwrite(nomf,tab,20);

     // symbole de l'anode
     s:= '  ';
     chaine_to_car(s,tab,2);
     blockwrite(nomf,tab,2);
     //Lambda1,lambda2,intensity ratio
     r4:=lambda1_raw;
     blockwrite(nomf,r4,4);
     r4:=lambda2_raw;
     blockwrite(nomf,r4,4);
     r4:=ratio_raw;
     blockwrite(nomf,r4,4);
     // Code diffractometre et mot de configuration
     i2:=0;
     blockwrite(nomf,i2,2);
     i2:=0;
     blockwrite(nomf,i2,2);
     // lambda3
     r4:=1.39;
     blockwrite(nomf,r4,4);
     // Temps total en secondes
     r4:=1000;
     blockwrite(nomf,r4,4);
     // Date/temps au format Lotus
     r8:=0;
     blockwrite(nomf,r8,8);
     // 34 bytes libres pour expansion
     s:='';
     chaine_to_car(s,tab,34);
     blockwrite(nomf,tab,34);

// header tranche
     // Nbre total de bytes dans le header de tranche
     i2:=60;
     blockwrite(nomf,i2,2);
     // step_count pour la tranche
     i2:=nb_raies_raw;
     blockwrite(nomf,i2,2);
     // Identificateur de mode de couplage
     i2:=10;
     blockwrite(nomf,i2,2);
     // Mode pas  pas
     i2:=0;
     blockwrite(nomf,i2,2);
     // Temps de comptage (step_time)
     r4:=1;
     blockwrite(nomf,r4,4);
     // Pas (step_size)
     r4:=(x_theta[nb_raies_raw]-x_theta[1])/(nb_raies_raw-1);
     blockwrite(nomf,r4,4);
     // Angles de dpart
     r4:=x_theta[1];
     blockwrite(nomf,r4,4);
     r4:=theta_min/2;
     blockwrite(nomf,r4,4);
     r4:=0;for i:=1 to 4 do blockwrite(nomf,r4,4);
     // addr 40  48
     i2:=0;
     for i:=1 to 5 do blockwrite(nomf,i2,2);
     //  ddr 50  54
     r4:=0;
     for i:=1 to 2 do blockwrite(nomf,r4,4);
     // addr 58  60
     i2:=0;
     blockwrite(nomf,i2,2);
// Donnes diagramme
     for i:=1 to nb_raies_raw do begin
       r4:=100*y_intensite[i];
       blockwrite(nomf,r4,4);
     end;
     closeFile(nomf);
end;

procedure ecrit_cpi;
//------------------
var
  nomf            : textFile;
  i               : integer;
begin
  assignfile(nomf,nom_fichier_sim);
  rewrite(nomf);
  writeln(nomf,'SIETRONICS XRD SCAN');
  writeln(nomf,theta_min:7:3);
  writeln(nomf,theta_max:7:3);
  writeln(nomf,(x_theta[2]-x_theta[1]):7:3);
  writeln(nomf,anode_raw);
  writeln(nomf,lambda_raw:8:5);
  writeln(nomf,datetostr(Date));
  writeln(nomf,'1');
  writeln(nomf,'SampleIdent '+titre);
  writeln(nomf,'SCANDATA');
  for i:=1 to nb_raies_raw do writeln(nomf,100*y_intensite[i]:10:0);
  closeFile(nomf);
  showmessage('The peak positions were saved in the file '+nom_fichier_dif);
end;
//=======================Lecture fichiers paramtres==========================
//Lecture des paramtres dans un fichier CRY
procedure lit_fichier_cry;
//-----------------------
var
   nomf                            : TextFile;
   i                               : integer;
   s                               : string;
begin
 // with form1 do begin
    AssignFile(nomf,nom_fichier_ind);
    reset(nomf);
    readln(nomf,titre);
    readln(nomf,systeme);
    if (systeme = 'QUAD') then systeme:='TETR';
    readln(nomf,groupe_espace);
    groupe_espace:=trim(groupe_espace);
    for i:=1 to 6 do begin
       read(nomf,cel[i]);
       cel_depart[i]:=cel[i];
    end;
    readln(nomf);
    closefile(nomf);
end;

procedure lit_fichier_icsd;
//-------------------------
var
   nomf                            : TextFile;
   i,j,n,ier                       : integer;
   s,s1,nom_fichier                : string;
   c4                              : string[4];
   tableau                         : tab_reel;
begin
    //Lecture du fichier ICSD
    teste_fichier_unix(nom_fichier_ind,ier);
    if (ier > 0)then  nom_fichier:='dummy.tmp' else nom_fichier:=nom_fichier_ind;
    AssignFile(nomf,nom_fichier);
    reset(nomf);
    while not(eof(nomf)) do begin
      readln(nomf,c4,s);
      //dcodage titre
      if (c4 = 'TITL')then begin
        titre:=s;
        continue;
      end;
      //Dcodage paramtres
      c4:=trim(c4);
      s:=trim(s);
      if (c4 = 'CELL')then begin
        for i:=1 to 6 do begin
              j:=pos('=',s);
              delete(s,j-1,2);
        end;
        while (pos('(',s) > 0)do begin
              i:=pos('(',s);
              j:=pos(')',s);
              delete(s,i,j-i+1);
        end;
        j:=6;
        dec(s,tableau,j,ier);
        if (ier = 0)then begin
              for i:=1 to 6 do begin
                cel[i]:=tableau[i];
                cel_depart[i]:=cel[i];
              end;
              quel_systeme;
        end else begin
              erreur('Cell parameters not found!');
              closeFile(nomf);
              exit;
            end;
        end;
        //Dcodage groupe d'espace
        if (c4 = 'SGR')then begin
            i:=pos('(',s);
            s1:=copy(s,1,i-1);
            s1:=trim(s1);
            groupe_espace:='';
            while (pos(' ',s1) > 0) do delete(s1,pos(' ',s1),1);
            if (s1[length(s1)] = 'H')then delete (s1,length(s1),1);
            groupe_espace:=s1;
            break;
        end;
      end;
      closefile(nomf);
end;

end.
