unit lisse2;

interface
//=======
uses mathhkl;
type
veryLongVector            = array[0..10000] of real;
ShortVector               = array[0..100] of real;

PROCEDURE DataSmoothSg(var dataset:    veryLongVector;
                          numdat,
                          smoothnum,
                          derivnum:   integer;
                      var smoothdata:  veryLongVector);

(*procedure DataSmoothWeights(var dataset:    veryLongVector;
                          numdat,
                          smoothnum:   integer;
                          weights:      ShortVector;
                          wdivisor:     real;
                      var smoothdata:  veryLongVector);

*)
implementation
//============

PROCEDURE DataSmoothSg(var dataset:    veryLongVector;
                          numdat,
                          smoothnum,
                          derivnum:   integer;
                      var smoothdata:  veryLongVector);

type  smoothcoeftype = array[0..2,1..5,1..13] of integer;
      normcoeftype =    array[0..2,1..5] of integer;
const smoothcoef : smoothcoeftype =
                   (((-3,12,17,12,-3,0,0,0,0,0,0,0,0),
                    (-2,3,6,7,6,3,-2,0,0,0,0,0,0),
                    (-21,14,39,54,59,54,39,14,-21,0,0,0,0),
                    (-36,9,44,69,84,89,84,69,44,9,-36,0,0),
                    (-11,0,9,16,21,24,25,24,21,16,9,0,-11)),
                    ((-2,-1,0,1,2,0,0,0,0,0,0,0,0),
                    (-3,-2,-1,0,1,2,3,0,0,0,0,0,0),
                    (-4,-3,-2,-1,0,1,2,3,4,0,0,0,0),
                    (-5,-4,-3,-2,-1,0,1,2,3,4,5,0,0),
                    (-6,-5,-4,-3,-2,-1,0,1,2,3,4,5,6)),
                    ((2,-1,-2,-1,2,0,0,0,0,0,0,0,0),
                    (5,0,-3,-4,-3,0,5,0,0,0,0,0,0),
                    (28,7,-8,-17,-20,-17,-8,7,28,0,0,0,0),
                    (15,6,-1,-6,-9,-10,-9,-6,-1,6,15,0,0),
                    (22,11,2,-5,-10,-13,-14,-13,-10,-5,2,11,22)));

      normcoef:     normcoeftype = ((35,21,231,429,143),
                                  (10,28,60,110,182),
                                  (7,42,462,429,1001));


var  i,j,k ,smoothdeg,
     startconv,stopconv,
     numcoef              :    integer;

begin
  if (smoothnum >= 1) and (smoothnum <= 5)  and (derivnum >= 0)
     and (derivnum <= 2) then
  begin
    numcoef := 2 * smoothnum + 3;
    smoothdeg := (numcoef - 1) div 2;
    startconv := smoothdeg + 1;
    stopconv := numdat - smoothdeg;
    for i:= 0 to numdat do
      smoothdata[i] := 0;
    for i:= startconv to  stopconv do
    begin
      for j:= 0 to numcoef - 1 do
        smoothdata[i] := smoothdata[i] +
                         dataset[i-smoothdeg+j] *
                         smoothcoef[derivnum,smoothnum,j+1];
      smoothdata[i] := smoothdata[i]/normcoef[derivnum,smoothnum];
    end;
    j:= smoothdeg;
    k:= numdat - smoothdeg + 1;
    for i:= 1 to smoothdeg do
    begin
      smoothdata[j] := smoothdata[j+1];
      smoothdata[k] := smoothdata[k-1];
      j := j - 1;
      k := k + 1;
    end;
  end
end;


(*procedure DataSmoothWeights(var dataset:    veryLongVector;
                          numdat,
                          smoothnum:   integer;
                          weights:      ShortVector;
                          wdivisor:     real;
                      var smoothdata:  veryLongVector);


var  i,j,k ,smoothdeg,
     startconv,stopconv,
     numcoef              :    integer;

begin
  if (smoothnum >= 1) and (odd(smoothnum)) then
  begin
    smoothdeg := smoothnum  div 2 ;
    startconv := smoothdeg + 1;
    stopconv := numdat - smoothdeg;
    for i:= 0 to numdat do
      smoothdata[i] := 0;
    for i:= startconv to  stopconv do
    begin
      for j:= 0 to smoothnum - 1 do
        smoothdata[i] := smoothdata[i] + dataset[i - smoothdeg + j] *
                         weights[j+1];

      smoothdata[i] := smoothdata[i]/wdivisor;
    end;
    j:= smoothdeg;
    k:= numdat - smoothdeg + 1;
    for i:= 1 to smoothdeg do
    begin
      smoothdata[j] := smoothdata[j+1];
      smoothdata[k] := smoothdata[k-1];
      j := j - 1;
      k := k + 1;
    end;
  end
end; *)


end.
