unit mathhkl_3;

interface

Uses
  SysUtils, WinTypes, WinProcs, Messages,
  Controls, StdCtrls, dialogs, math, matmath,StdHdr;

type
    tab_reel8            =  array[1..8] of double;
    tab_reel6            =  array[1..6] of double;
    tab_reel500          =  array[1..500] of double;
    tab_int500           =  array[1..500] of integer;
    tab_mat              =  array[1..500,1..8] of double;
    matrice3             =  array[1..3,1..3] of double ;
    vecteur3             =  array[1..3] of double;
var
    mess,titre                               : string;
    afi,sig_dir,sig_rec,par,b                : tab_reel8;
    h,k,l                                    : tab_int500;
    th_obs,th_calc,sec_membre                : tab_reel500;
    nr,indic,npaf,npaf2                      : integer;
    cel,celr                                 : tab_reel6;
    qnr,qnpaf,qt                             : tab_mat;
    volume,resid,sigma_vol                   : double;
{Matrices}
    r10,r01,r21,r12,r13,r31,r23,r32,r20,r02  : matrice3;
    r30,r03                                  : matrice3;
    det_mat                                  : double;

const
  pir         = 57.295780;
  pir2        = 114.591559;

procedure erreur   (s:string);
procedure matinv3   (Mat : matrice3; var mati :matrice3);
Procedure ident    (mat : matrice3; var mati :matrice3);
procedure trspo    (var mat : matrice3);
procedure trfo     (u1,u2,u3: double; var v1,v2,v3 : double; var r : matrice3);
procedure trfo2    (var u1,u2,u3 : double; var r : matrice3);
procedure trfo3    (var v : vecteur3; var r : matrice3);
procedure mat_mult (ma,mb : matrice3; var mc : matrice3);
procedure setmat;
procedure reel_recip(var mi,mo:tab_reel6);
procedure matinv(var q_in:tab_mat; var n,ier:integer);

implementation
{Calcul des diffrentes matrices}

procedure erreur(s:string);{
---------------------------}
begin
   MessageDlg(s,mtWarning,[mbOK],0);
end;

procedure reel_recip(var mi,mo:tab_reel6);
//----------------------------------------
var
      q,v                                                       : double;
      a,b,c,alpha,beta,gamma                                    : double;
      ca,cb,cc,sa,sb,sc,sbe,sce,cae,cbe,cce                     : double;
begin
      a:=mi[1];
      b:=mi[2];
      c:=mi[3];
      alpha:=mi[4];
      beta:=mi[5];
      gamma:=mi[6];
      ca:=cos(mi[4]);
      cb:=cos(mi[5]);
      cc:=cos(mi[6]);
      sa:=sin(mi[4]);
      sb:=sin(mi[5]);
      sc:=sin(mi[6]);
      q:=1.-ca*ca-cb*cb-cc*cc+2.*ca*cb*cc;
      v:=a*b*c*sqrt(q);
      volume:=1/v;
      mo[1]:=b*c*sa/v;
      mo[2]:=c*a*sb/v;
      mo[3]:=a*b*sc/v;
      cae:=(cb*cc-ca)/(sb*sc);
      cbe:=(cc*ca-cb)/(sc*sa);
      cce:=(ca*cb-cc)/(sa*sb);
      mo[4]:=arccos(cae);
      mo[5]:=arccos(cbe);
      sbe:=sin(mo[5]);
      mo[6]:=arccos(cce);
  end;

procedure setmat;{
-----------------}
var
      q,v                                                       : double;
      i,j                                                       : integer;
      aux                                                       : matrice3;
      a,b,c,alpha,beta,gamma,ae,be,ce,alphae,betae,gammae       : double;
      ca,cb,cc,sa,sb,sc,sbe,sce,cae,cbe,cce                     : double;
begin
      a:=cel[1];
      b:=cel[2];
      c:=cel[3];
      alpha:=cel[4];
      beta:=cel[5];
      gamma:=cel[6];
      ca:=cos(cel[4]/pir);
      cb:=cos(cel[5]/pir);
      cc:=cos(cel[6]/pir);
      sa:=sin(cel[4]/pir);
      sb:=sin(cel[5]/pir);
      sc:=sin(cel[6]/pir);
      q:=1.-ca*ca-cb*cb-cc*cc+2.*ca*cb*cc;
      v:=a*b*c*sqrt(q);
      volume:=v;
      celr[1]:=b*c*sa/v;
      celr[2]:=c*a*sb/v;
      celr[3]:=a*b*sc/v;
      cae:=(cb*cc-ca)/(sb*sc);
      cbe:=(cc*ca-cb)/(sc*sa);
      cce:=(ca*cb-cc)/(sa*sb);
      celr[4]:=arccos(cae);
//celr[4]:=celr[4]*pir;
      celr[5]:=arccos(cbe);
      sbe:=sin(celr[5]);
//celr[5]:=celr[5]*pir;
      celr[6]:=arccos(cce);
      sce:=sin(celr[6]);
//celr[6]:=celr[6]*pir;
      ae:=celr[1];
      be:=celr[2];
      ce:=celr[3];

{-----Calcul de la matrice de passage du r.r. au res. rl et inversemt}
      r01[1,1]:=ae*ae;
      r01[1,2]:=ae*be*cce;
      r01[1,3]:=ae*ce*cbe;
      r01[2,2]:=be*be;
      r01[2,3]:=ce*be*cae;
      r01[3,3]:=ce*ce;

      r10[1,1]:=a*a;
      r10[1,2]:=a*b*cc;
      r10[1,3]:=a*c*cb;
      r10[2,2]:=b*b;
      r10[2,3]:=c*b*ca;
      r10[3,3]:=c*c;

      for i:=1 to 3 do begin
        for j:=1 to 3 do begin
          r01[j,i]:=r01[i,j];
          r10[j,i]:=r10[i,j];
        end;
      end;

{-----Orthonormalisation du rseau rciproque R21}
      for i:=1 to 3 do begin
        for j:=1 to 3 do begin
          r21[i,j]:=0.;
        end;
      end;
      r21[1,1]:=celr[1];
      r21[1,2]:=celr[2]*cce;
      r21[1,3]:=celr[3]*cbe;
      r21[2,2]:=celr[2]*sce;
      r21[2,3]:=-celr[3]*sbe*ca;
      r21[3,3]:=1./cel[3];

{-----Orthonormalisation du rseau direct R20}
      matinv3(r21,r12);
      mat_mult(r21,r10,r20);
      mat_mult(r01,r12,r02);
      mat_mult(r01,r10,aux);

{-----Matrices R03 et R30 de dpart}
      for i:=1 to 3 do begin
       for j:=1 to 3 do begin
          r23[i,j]:=0;
          r32[i,j]:=0;
          if (i = j) then begin
            r23[i,j]:=1;
            r32[i,j]:=1;
          end;
       end;
      end;
      mat_mult(r02,r23,r03);
      mat_mult(r23,r20,r30);
end;

function  Det      (Mat:matrice3): double;{
----------------------------------------}
begin
  det:=mat[1,1]*(mat[2,2]*mat[3,3]-mat[3,2]*mat[2,3])
      -mat[1,2]*(mat[2,1]*mat[3,3]-mat[3,1]*mat[2,3])
      +mat[1,3]*(mat[2,1]*mat[3,2]-mat[3,1]*mat[2,2]);
end;

{Inversion de matrice}
procedure matinv3   (Mat : matrice3; var Mati : matrice3);{
---------------------------------------------------------}
var
  i,j      : integer;

begin
  mati[1,1]:=mat[2,2]*mat[3,3]-mat[2,3]*mat[3,2];
  mati[1,2]:=mat[1,3]*mat[3,2]-mat[1,2]*mat[3,3];
  mati[1,3]:=mat[1,2]*mat[2,3]-mat[1,3]*mat[2,2];

  mati[2,1]:=mat[2,3]*mat[3,1]-mat[2,1]*mat[3,3];
  mati[2,2]:=mat[1,1]*mat[3,3]-mat[1,3]*mat[3,1];
  mati[2,3]:=mat[1,3]*mat[2,1]-mat[1,1]*mat[2,3];

  mati[3,1]:=mat[2,1]*mat[3,2]-mat[2,2]*mat[3,1];
  mati[3,2]:=mat[1,2]*mat[3,1]-mat[1,1]*mat[3,2];
  mati[3,3]:=mat[1,1]*mat[2,2]-mat[1,2]*mat[2,1];

  det_mat:=det(Mat);
  if(abs(det_mat) < 0.00001)then begin
    erreur('Matrice singulire');
    exit;
  end;
  For i:=1 to 3 do begin
    For j:= 1 to 3 do begin
      mati[i,j]:= mati[i,j]/det_mat;
    end;
  end;
end;

Procedure ident (mat : matrice3; var mati :matrice3);{
-----------------------------------------------------}
var i,j  :integer;
begin
  for i:=1 to 3 do begin
    for j:=1 to 3 do begin
      mati[i,j]:=mat[i,j];
    end;
  end;
end;

procedure trspo    (var mat : matrice3);{
----------------------------------------}
var
  i,j  :integer;
  mati :matrice3;
begin
  ident(mat,mati);
  for i:=1 to 3 do begin
    for j:=1 to 3 do begin
      mat[i,j]:=mati[j,i];
    end;
  end;
end;

procedure trfo (u1,u2,u3: double; var v1,v2,v3 : double; var r : matrice3);{
-----------------------------------------------------------------------}
begin
  v1:=u1*r[1,1]+u2*r[1,2]+u3*r[1,3];
  v2:=u1*r[2,1]+u2*r[2,2]+u3*r[2,3];
  v3:=u1*r[3,1]+u2*r[3,2]+u3*r[3,3];
end;

procedure trfo2(var u1,u2,u3 : double; var r : matrice3);{
-------------------------------------------------------}
var
  v1,v2,v3  : double;
begin
  v1:=u1*r[1,1]+u2*r[1,2]+u3*r[1,3];
  v2:=u1*r[2,1]+u2*r[2,2]+u3*r[2,3];
  v3:=u1*r[3,1]+u2*r[3,2]+u3*r[3,3];
  u1:=v1;
  u2:=v2;
  u3:=v3
end;

procedure trfo3(var v : vecteur3; var r : matrice3);{
----------------------------------------------------}
var
  v1,v2,v3  : double;
begin
  v1:=v[1]*r[1,1]+v[2]*r[1,2]+v[3]*r[1,3];
  v2:=v[1]*r[2,1]+v[2]*r[2,2]+v[3]*r[2,3];
  v3:=v[1]*r[3,1]+v[2]*r[3,2]+v[3]*r[3,3];
  v[1]:=v1;
  v[2]:=v2;
  v[3]:=v3;
end;

{Produit vectoriel}
Procedure prodvec(x,y: vecteur3; var z :vecteur3);{
--------------------------------------------------}
begin
   z[1]:=x[2]*y[3]-x[3]*y[2];
   z[2]:=x[3]*y[1]-x[1]*y[3];
   z[3]:=x[1]*y[2]-x[2]*y[1];
end;

{Multiplication de matrices}
procedure mat_mult (ma,mb: matrice3; var mc : matrice3);{
--------------------------------------------------------}
var
  i,j,k :integer;
begin
  for k:=1 to 3 do begin
    for j:=1 to 3 do begin
      mc[j,k]:=0;
      for i:=1 to 3 do begin
        mc[j,k]:=mc[j,k]+ma[j,i]*mb[i,k];
      end;
    end;
  end;
end;

procedure matinv(var q_in:tab_mat; var n,ier:integer);
//------------------------------------------------
var
  i,j,numcol           : integer;
  mat_in,mat_out       : recmat;
  det                  : double;
begin
 for i:=1 to 8 do begin
   for j:=1 to 8 do begin
     mat_in[j-1,i-1]:=q_in[i,j];
   end;
 end;
 numcol:=n;
 ier:=0;
 matinvert(mat_in,numcol,det,mat_out);
 if (abs(det) < 1e-6)then begin
    ier:=1;
    exit;
 end;
 for i:=1 to 6 do begin
   for j:=1 to 6 do begin
     q_in[j,i]:=mat_out[i-1,j-1];
   end;
 end;
end;

end.
